<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.1"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format"
                xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
                xsi:schemaLocation="http://www.w3.org/1999/XSL/Format
                http://svn.apache.org/repos/asf/xmlgraphics/fop/trunk/src/foschema/fop.xsd"
                exclude-result-prefixes="fo">
    <xsl:output method="xml" version="1.0" omit-xml-declaration="no"
                indent="yes" />

    <xsl:template match="/">
        <fo:root>
            <fo:layout-master-set>
                <fo:simple-page-master master-name="A4-portrait" page-height="29.7cm" page-width="21.0cm" margin="2cm">
                    <fo:region-body/>
                </fo:simple-page-master>
            </fo:layout-master-set>

            <fo:page-sequence master-reference="A4-portrait">
                <fo:flow flow-name="xsl-region-body">
                    <fo:block space-after="2mm">
                        <fo:table width="100%">
                            <fo:table-body>
                                <fo:table-row>
                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="4">
                                        <fo:block font-weight="bold">
                                            Представительный элемент объема
                                        </fo:block>
                                    </fo:table-cell>
                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="2">
                                        <fo:block>
                                            <xsl:value-of select="ec/name" />
                                        </fo:block>
                                    </fo:table-cell>
                                </fo:table-row>
                                <fo:table-row>
                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="2">
                                        <fo:block font-weight="bold">
                                            Дата создания
                                        </fo:block>
                                    </fo:table-cell>
                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="2">
                                        <fo:block>
                                            <xsl:value-of select="ec/date" />
                                        </fo:block>
                                    </fo:table-cell>
                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="2" number-rows-spanned="2">
                                        <fo:block/>
                                    </fo:table-cell>
                                </fo:table-row>
                                <fo:table-row>
                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="2">
                                        <fo:block font-weight="bold">
                                            Пользователь
                                        </fo:block>
                                    </fo:table-cell>
                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="2">
                                        <fo:block>
                                            <xsl:value-of select="ec/user" />
                                        </fo:block>
                                    </fo:table-cell>
                                </fo:table-row>
                            </fo:table-body>
                        </fo:table>
                    </fo:block>
                    <!-- ###################################################################################################### -->
                    <fo:block space-after="2mm">
                        <fo:table width="100%">
                            <fo:table-body>
                                <fo:table-row>
                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="6">
                                        <fo:block font-weight="bold">Параметры ПЭО на уровне микроструктуры</fo:block>
                                    </fo:table-cell>
                                </fo:table-row>
                                <xsl:for-each select="ec/parammicro/parameter">
                                    <xsl:choose>
                                        <xsl:when test="isComposite = 'true'">
                                            <fo:table-row>
                                                <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="6">
                                                    <fo:block><xsl:value-of select="name" /></fo:block>
                                                </fo:table-cell>
                                            </fo:table-row>
                                            <xsl:for-each select="children">
                                                <fo:table-row>
                                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="3">
                                                        <fo:block><xsl:value-of select="name" /></fo:block>
                                                    </fo:table-cell>
                                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="3">
                                                        <fo:block><xsl:value-of select="value" /></fo:block>
                                                    </fo:table-cell>
                                                </fo:table-row>
                                            </xsl:for-each>
                                        </xsl:when>
                                        <xsl:otherwise>
                                            <fo:table-row>
                                                <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="4">
                                                    <fo:block><xsl:value-of select="name" /></fo:block>
                                                </fo:table-cell>
                                                <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="2">
                                                    <fo:block><xsl:value-of select="value" /></fo:block>
                                                </fo:table-cell>
                                            </fo:table-row>
                                        </xsl:otherwise>
                                    </xsl:choose>
                                </xsl:for-each>
                            </fo:table-body>
                        </fo:table>
                    </fo:block>
                    <!-- ###################################################################################################### -->
                    <fo:block space-after="2mm">
                        <fo:table width="100%">
                            <fo:table-body>
                                <fo:table-row>
                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="6">
                                        <fo:block font-weight="bold">Параметры ПЭО на уровне мезоструктуры</fo:block>
                                    </fo:table-cell>
                                </fo:table-row>
                                <xsl:for-each select="ec/parammeso/parameter">
                                    <xsl:choose>
                                        <xsl:when test="isComposite = 'true'">
                                            <fo:table-row>
                                                <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="6">
                                                    <fo:block><xsl:value-of select="name" /></fo:block>
                                                </fo:table-cell>
                                            </fo:table-row>
                                            <xsl:for-each select="children">
                                                <fo:table-row>
                                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="3">
                                                        <fo:block><xsl:value-of select="name" /></fo:block>
                                                    </fo:table-cell>
                                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="3">
                                                        <fo:block><xsl:value-of select="value" /></fo:block>
                                                    </fo:table-cell>
                                                </fo:table-row>
                                            </xsl:for-each>
                                        </xsl:when>
                                        <xsl:otherwise>
                                            <fo:table-row>
                                                <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="4">
                                                    <fo:block><xsl:value-of select="name" /></fo:block>
                                                </fo:table-cell>
                                                <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="2">
                                                    <fo:block><xsl:value-of select="value" /></fo:block>
                                                </fo:table-cell>
                                            </fo:table-row>
                                        </xsl:otherwise>
                                    </xsl:choose>
                                </xsl:for-each>
                            </fo:table-body>
                        </fo:table>
                    </fo:block>
                    <!-- ###################################################################################################### -->
                    <fo:block space-after="2mm">
                        <fo:table width="100%">
                            <fo:table-body>
                                <fo:table-row>
                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="6">
                                        <fo:block font-weight="bold">Параметры дефектов</fo:block>
                                    </fo:table-cell>
                                </fo:table-row>
                                <fo:table-row>
                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="2">
                                        <fo:block>
                                            Тип дефекта
                                        </fo:block>
                                    </fo:table-cell>
                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle">
                                        <fo:block>
                                            Процентное содержание
                                        </fo:block>
                                    </fo:table-cell>
                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle">
                                        <fo:block>
                                            Толщина дефекта
                                        </fo:block>
                                    </fo:table-cell>
                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle">
                                        <fo:block>
                                            Ширина дефекта
                                        </fo:block>
                                    </fo:table-cell>
                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle">
                                        <fo:block>
                                            Длина дефекта
                                        </fo:block>
                                    </fo:table-cell>
                                </fo:table-row>
                                <xsl:for-each select="ec/defects/defect">
                                    <fo:table-row>
                                        <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="2">
                                            <fo:block>
                                                <fo:block><xsl:value-of select="name" /></fo:block>
                                            </fo:block>
                                        </fo:table-cell>
                                        <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle">
                                            <fo:block>
                                                <fo:block><xsl:value-of select="perc" /></fo:block>
                                            </fo:block>
                                        </fo:table-cell>
                                        <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle">
                                            <fo:block>
                                                <fo:block><xsl:value-of select="thic" /></fo:block>
                                            </fo:block>
                                        </fo:table-cell>
                                        <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle">
                                            <fo:block>
                                                <fo:block><xsl:value-of select="wid" /></fo:block>
                                            </fo:block>
                                        </fo:table-cell>
                                        <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle">
                                            <fo:block>
                                                <fo:block><xsl:value-of select="len" /></fo:block>
                                            </fo:block>
                                        </fo:table-cell>
                                    </fo:table-row>
                                </xsl:for-each>
                            </fo:table-body>
                        </fo:table>
                    </fo:block>
                    <!-- ###################################################################################################### -->
                    <fo:block space-after="2mm">
                        <fo:table width="100%">
                            <fo:table-body>
                                <fo:table-row>
                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="6">
                                        <fo:block font-weight="bold">Эффективные характеристики ПЭО на уровне микроструктуры</fo:block>
                                    </fo:table-cell>
                                </fo:table-row>
                                <xsl:variable name="ecmicroLength" select="ec/ecmicroLength + 1" />
                                <fo:table-row>
                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="4">
                                        <fo:block>&#160;</fo:block>
                                    </fo:table-cell>
                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="2" number-rows-spanned="{$ecmicroLength}">
                                        <fo:block-container height="5mm">
                                            <fo:block wrap-option="wrap" text-align="center" font-size="0pt">
                                                <fo:external-graphic overflow="scroll"
                                                                     content-width="5cm" src="">
                                                    <xsl:attribute name="src">
                                                        <xsl:value-of select="ec/microPic" />
                                                    </xsl:attribute>
                                                </fo:external-graphic>
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                </fo:table-row>
                                <xsl:for-each select="ec/ecmicro/parameter">
                                    <fo:table-row>
                                        <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="2">
                                            <fo:block>
                                                <fo:block><xsl:value-of select="name" /></fo:block>
                                            </fo:block>
                                        </fo:table-cell>
                                        <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="2">
                                            <fo:block>
                                                <fo:block><xsl:value-of select="value" /></fo:block>
                                            </fo:block>
                                        </fo:table-cell>
                                    </fo:table-row>
                                </xsl:for-each>
                            </fo:table-body>
                        </fo:table>
                    </fo:block>
                    <!-- ###################################################################################################### -->
                    <fo:block space-after="2mm" break-before="page">
                        <fo:table width="100%">
                            <fo:table-body>
                                <fo:table-row>
                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="6">
                                        <fo:block font-weight="bold">Эффективные характеристики ПЭО на уровне мезоструктуры</fo:block>
                                    </fo:table-cell>
                                </fo:table-row>
                                <xsl:variable name="ecmesoLength" select="ec/ecmesoLength + 1" />
                                <fo:table-row>
                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="4">
                                        <fo:block>&#160;</fo:block>
                                    </fo:table-cell>
                                    <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="2" number-rows-spanned="{$ecmesoLength}">
                                        <fo:block-container height="5mm">
                                            <fo:block wrap-option="wrap" text-align="center" font-size="0pt">
                                                <fo:external-graphic overflow="scroll"
                                                                     content-width="5cm" src="">
                                                    <xsl:attribute name="src">
                                                        <xsl:value-of select="ec/mesoPic" />
                                                    </xsl:attribute>
                                                </fo:external-graphic>
                                            </fo:block>
                                        </fo:block-container>
                                    </fo:table-cell>
                                </fo:table-row>
                                <xsl:for-each select="ec/ecmeso/parameter">
                                    <fo:table-row>
                                        <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="2">
                                            <fo:block>
                                                <fo:block><xsl:value-of select="name" /></fo:block>
                                            </fo:block>
                                        </fo:table-cell>
                                        <fo:table-cell border-width="1pt" border-style="solid" vertical-align="middle" number-columns-spanned="2">
                                            <fo:block>
                                                <fo:block><xsl:value-of select="value" /></fo:block>
                                            </fo:block>
                                        </fo:table-cell>
                                    </fo:table-row>
                                </xsl:for-each>
                            </fo:table-body>
                        </fo:table>
                    </fo:block>
                </fo:flow>
            </fo:page-sequence>

        </fo:root>
    </xsl:template>

</xsl:stylesheet>
