package ru.crp.lvms.events.listeners;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.event.EventListener;
import org.springframework.stereotype.Component;
import ru.crp.lvms.events.NodeStatusUpdatedEvent;
import ru.crp.lvms.events.TasksAddedToQueueEvent;
import ru.crp.lvms.tasks.StartTasksJob;

// listen all events after which we need to check tasks queue
@Component
public class StartTasksQueueListener {
    private static final Logger LOGGER = LoggerFactory.getLogger(StartTasksQueueListener.class);

    @Autowired
    private StartTasksJob startTasksJob;

    @EventListener
    public void onNodeUpdated(NodeStatusUpdatedEvent event) {
        // may be in task queue there are some tasks that can be calculated on new node
        startTasksJob.checkTaskQueueManually();
    }

    @EventListener
    public void onTasksAddedToQueue(TasksAddedToQueueEvent event) {
        startTasksJob.checkTaskQueueManually();
    }
}
