package ru.crp.lvms.exceptions;

import ru.crp.lvms.utils.NamingUtils;

import java.util.Map;
import java.util.stream.Collectors;

public class BadRequestException extends RuntimeException {
    public BadRequestException(String message) {
        super(message);
    }

    public BadRequestException(String message, Throwable cause) {
        super(message, cause);
    }

    public static BadRequestException createDeleteMultipleException(Class clazz, Map<?, Exception> errors) {
        return new BadRequestException(String.format("An error occurred while deleting %ss: %s",
                NamingUtils.getHumanReadableClassName(clazz),
                errors.values().stream()
                        .map(Exception::getMessage)
                        .collect(Collectors.joining("; "))));
    }
}
