package ru.crp.lvms.managers.tasks;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import ru.crp.lvms.managers.SimulationManager;
import ru.crp.lvms.model.entities.UserEntity;
import ru.crp.lvms.model.entities.simulations.SimulationEntity;
import ru.crp.lvms.model.entities.simulations.SimulationType;
import ru.crp.lvms.model.entities.tasks.TaskEntity;
import ru.crp.lvms.optimizations.base.enums.OptimizationCae;

import java.util.List;

import static java.util.Collections.singletonList;

@Service
public class SimulationTaskManager {

    @Autowired
    private SimulationManager simulationManager;

    public List<TaskEntity> createChainOfTasksForSimulation(TaskEntity newTask, UserEntity user) {
        if (newTask.getSolverName() == null) {
            newTask.setSolverName(OptimizationCae.ANSYS.getSolverConfigName());
        }
        SimulationEntity parent = simulationManager.findOne(newTask.getParentId(), user);
        newTask.setType(SimulationType.valueOf(parent.getTypeId()).toTaskType());
        return singletonList(newTask);
    }
}
