package ru.crp.lvms.model;

import ru.crp.lvms.optimizations.base.enums.OptimizationTypes;

public enum FolderColor {
    BROWN, MAGENTA, GREEN, RED, ORANGE, BLUE, PURPLE, BLACK;

    public static FolderColor fromOptimizationType(OptimizationTypes optimizationTypes) {
        switch (optimizationTypes) {
            case EngineeringCalculation:
                return FolderColor.BROWN;
            case TopologicalOptimization:
                return FolderColor.BLUE;
            case TopographicOptimization:
                return FolderColor.GREEN;
            case ParametricShapeOptimization:
                return FolderColor.ORANGE;
//            case TopologicalOptimizationOfMicrostructure:
//                return FolderColor.BLUE;
            case ParametricOptimizationOfMicrostructure:
                return FolderColor.PURPLE;
            case ShapeOptimization:
                return FolderColor.RED;
            default:
                return FolderColor.BLACK;
        }
    }
}
