package ru.crp.lvms.model;

import com.fasterxml.jackson.annotation.JsonInclude;
import ru.crp.lvms.cluster.ClustersManager;
import ru.crp.lvms.cluster.model.ClusterEntity;
import ru.crp.lvms.cluster.model.ClusterType;
import ru.crp.lvms.model.entities.technology.TechnologyType;

@JsonInclude(JsonInclude.Include.NON_NULL)
public class SuggestDTO {
    private Object id;
    private String text;
    private String disabled;
    private Boolean selected;
    private ClusterType type;

    public SuggestDTO(TechnologyType type) {
        id = type.name();
        text = type.getDisplayName();
        if (type == TechnologyType.NOT_ADDITIVE) {
            selected = true;
        }
    }

    public SuggestDTO(ClusterEntity cluster) {
        id = cluster.getId();
        text = cluster.getName();
        type = cluster.getType();
        if (!cluster.getIsEnabled()) {
            disabled = "disabled";
        }
        if (cluster.getId() == ClustersManager.BENCH_LOCAL_CLUSTER_ID) {
            selected = true;
        }
    }

    public Object getId() {
        return id;
    }

    public String getText() {
        return text;
    }

    public String getDisabled() {
        return disabled;
    }

    public Boolean getSelected() {
        return selected;
    }

    public ClusterType getType() {
        return type;
    }
}

