package ru.crp.lvms.model.dao;

import ru.crp.cmlb.model.entities.base.Entity;
import ru.crp.lvms.managers.image.ImageFileContainer;

import javax.annotation.Nullable;
import java.util.Collection;

public abstract class BaseCompositeDao<ET extends Entity, E extends ET> extends BaseSpaceDao<E> {
    protected abstract BaseSpaceDao<ET> tableDao();

    @Override
    public int insert(E t) {
        return tableDao().insert(t);
    }


    @Override
    public E insertAndRead(E t) {
        int id = tableDao().insert(t);
        return findOne(id);
    }


    @Override
    public void update(E t) {
        tableDao().update(t);
    }


    @Override
    public E updateAndRead(E t) {
        update(t);
        return findOne(t.getId());
    }


    @Override
    public void delete(int id) {
        tableDao().delete(id);
    }


    @Override
    public E save(E t) {
        ET saved = tableDao().save(t);
        return findOne(saved.getId());
    }

    @Override
    public void updateImageFile(ImageFileContainer imageFileContainer, @Nullable Integer newImageFileId) {
        tableDao().updateImageFile(imageFileContainer, newImageFileId);
    }

    @Override
    public int saveAll(Collection<E> entities) {
        throw new UnsupportedOperationException();
    }
}
