package ru.crp.lvms.model.dao;

import org.springframework.stereotype.Repository;
import ru.crp.lvms.model.entities.ColumnPrefsEntity;

import java.util.List;

@Repository
public class ColumnsPreferencesDao extends BaseSpaceDao<ColumnPrefsEntity> {

    public List<ColumnPrefsEntity> findAllColumns(Integer userId, String tableName) {
        return find("WHERE user_id=? AND table_name=? ORDER BY order_num", userId, tableName);
    }

    public void restoreColumns(Integer userId, String tableName) {
        getJdbcTemplate().update(
                "UPDATE " + getTableName() + " SET is_excluded=false WHERE user_id=? AND table_name=?", userId,
                tableName);
    }

    public void deletePreferences(Integer userId, String tableName) {
        getJdbcTemplate().update("DELETE FROM " + getTableName() + " WHERE user_id=? AND table_name=?", userId,
                tableName);
    }

    public void deletePreferences(Integer userId) {
        getJdbcTemplate().update("DELETE FROM " + getTableName() + " WHERE user_id=?", userId);
    }

    public void createPreferences(Iterable<ColumnPrefsEntity> columns) {
        // todo change to batch update
        for (ColumnPrefsEntity en : columns) {
            insert(en);
        }
    }

    public int getPreferencesCount(Integer userId, String tableName) {
        return count("WHERE user_id=? AND table_name=?", new Object[]{userId, tableName});
    }

    public ColumnPrefsEntity getPreferencesForColumn(int userId, String tableName, String columnName) {
        return findOne("WHERE user_id=? AND table_name=? AND name=?", userId, tableName, columnName);
    }
}
