package ru.crp.lvms.model.dao;

import org.springframework.stereotype.Repository;
import ru.crp.lvms.model.entities.Layer;
import ru.crp.lvms.model.entities.technology.TechnologySimulationsRibsEntity;

import java.util.ArrayList;
import java.util.List;

@Repository
public class TechnologySimulationsRibsDao extends BaseSpaceDao<TechnologySimulationsRibsEntity> {
    private static final String DELETE_FOR_RIBS_SQL = "DELETE FROM technology_simulations_ribs_parameters WHERE technology_simulations_id = ?";
    private static final String BATCH_INSERT_SQL = "INSERT INTO technology_simulations_ribs_parameters (position, origin_x, origin_y, angle, steps, "
            + "technology_simulations_id) VALUES (?, ?, ?, ?,?, ?)";

    public List<TechnologySimulationsRibsEntity> findByTechnologySimulationsId(int technologySimulationsId) {
        return find("WHERE technology_simulations_id = ? ORDER BY position", technologySimulationsId);
    }


    public void deleteTechnologySimulationsRibs(int technologySimulationsId) {
        getJdbcTemplate().update(DELETE_FOR_RIBS_SQL, technologySimulationsId);
    }


    public void batchInsertTechnologySimulationsRibs(List<TechnologySimulationsRibsEntity> technology_simulations_ribs_parameters) {
        if (technology_simulations_ribs_parameters.isEmpty()) {
            return;
        }
        List<Object[]> paramsInsert = new ArrayList<>();
        technology_simulations_ribs_parameters.forEach(technologySimulationsRibsEntity -> paramsInsert.add(new Object[]{
                technologySimulationsRibsEntity.getPosition(), technologySimulationsRibsEntity.getOrigin_x(), technologySimulationsRibsEntity.getOrigin_y(), technologySimulationsRibsEntity.getAngle(), technologySimulationsRibsEntity.getSteps(), technologySimulationsRibsEntity.getTechnologySimulationId()
        }));
        getJdbcTemplate().batchUpdate(BATCH_INSERT_SQL, paramsInsert);
    }
}
