package ru.crp.lvms.model.dao.construction.elements;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Primary;
import org.springframework.stereotype.Component;
import org.springframework.stereotype.Repository;
import ru.crp.lvms.model.dao.BaseCompositeDao;
import ru.crp.lvms.model.dao.BaseSpaceDao;
import ru.crp.lvms.model.entities.construction.elements.ConstructionElementEntity;
import ru.crp.lvms.model.entities.construction.elements.ConstructionElementEntityTable;

@Repository
@Primary
public class ConstructionElementDao extends BaseCompositeDao<ConstructionElementEntityTable, ConstructionElementEntity> {
    @Component
    public static class TableDao extends BaseSpaceDao<ConstructionElementEntityTable> {

    }

    @Autowired
    private TableDao tableDao;

    @Override
    protected TableDao tableDao() {
        return tableDao;
    }

    public void addLinkToFile(int constructionElementId, int fileId) {
        jdbcTemplate().update("INSERT INTO construction_elements_files (construction_element_id, file_id) VALUES (?,?)",
                constructionElementId, fileId);
    }

    public void deleteLinkToFile(int constructionElementId, int fileId) {
        jdbcTemplate().update("DELETE FROM construction_elements_files WHERE construction_element_id = ? AND file_id = ?",
                constructionElementId, fileId);
    }
}
