package ru.crp.lvms.model.dao.effective.characteristics;

import org.springframework.stereotype.Repository;
import ru.crp.lvms.model.dao.BaseSpaceDao;
import ru.crp.lvms.model.entities.effective.characteristics.ECParamEntity;

import java.util.List;

@Repository
public class ECParamDao extends BaseSpaceDao<ECParamEntity> {
    public List<ECParamEntity> getByCharacteristicId(Integer ecId) {
        return find("WHERE effective_characteristic_id = ? ORDER BY param_id", ecId);
    }

    public List<ECParamEntity> getByCharacteristicId(Integer ecId, ECParamEntity.Type type) {
        return find("WHERE effective_characteristic_id = ? AND param_type = ? ORDER BY param_id", ecId, type.toString());
    }

    public ECParamEntity findOne(Integer id, Integer ecId) {
        return findOne("WHERE id = ? AND effective_characteristic_id = ?", id, ecId);
    }

    public ECParamEntity getByCharacteristicIdAndParamId(Integer ecId, Integer paramId) {
        return findOne("WHERE effective_characteristic_id = ? AND param_id = ?", ecId, paramId);
    }

    public List<Integer> getAllParamIds() {
        return jdbcTemplate().queryForList("SELECT id FROM effective_characteristics_parameters", Integer.class);
    }


}
