package ru.crp.lvms.model.entities;

import com.fasterxml.jackson.annotation.JsonIgnore;
import ru.crp.cmlb.model.entities.Column;
import ru.crp.cmlb.model.entities.Table;
import ru.crp.cmlb.model.entities.base.Entity;

import javax.annotation.Nullable;
import java.util.List;

@Table("parameters_materials_join")
public class ParameterValues implements Entity {
    private int id;

    @Column(value = "name", onlySelect = true)
    private String name;

    @Column(value = "material_id", onlySelect = true)
    private int materialId;

    @Column(value = "parameter_file_id", onlySelect = true)
    private Integer parameterFileId;

    private List<ParameterSample> valuesList;

    @Override
    public int getId() {
        return id;
    }

    @Override
    public void setId(int id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public List<ParameterSample> getValuesList() {
        return valuesList;
    }

    public void setValuesList(List<ParameterSample> valuesList) {
        this.valuesList = valuesList;
    }

    public int getMaterialId() {
        return materialId;
    }

    public void setMaterialId(int materialId) {
        this.materialId = materialId;
    }

    public Integer getParameterFileId() {
        return parameterFileId;
    }

    public void setParameterFileId(@Nullable Integer parameterFileId) {
        this.parameterFileId = parameterFileId;
    }

    @JsonIgnore
    public boolean hasFile() {
        return parameterFileId != null;
    }
}
