package ru.crp.lvms.model.entities;

import org.hibernate.validator.constraints.NotBlank;
import ru.crp.cmlb.model.entities.Column;
import ru.crp.cmlb.model.entities.Table;
import ru.crp.cmlb.model.entities.base.Named;
import ru.crp.lvms.model.entities.misc.AuditableImpl;
import ru.crp.lvms.validators.Unique;
import ru.crp.lvms.web.dto.columns.GridColumn;
import ru.crp.lvms.web.dto.columns.GridColumnType;

import javax.validation.constraints.NotNull;

@Table("parameters")
@Unique(entityClass = ParametersEntityTable.class, fieldName = "name", columnNane = "name",
        message = "Имя должно быть уникально")
public class ParametersEntityTable extends AuditableImpl implements Named {
    @NotBlank(message = "Имя параметра должно быть задано")
    @GridColumn(name = "name", label = "Название", order = 1, cell = GridColumnType.string)
    @Column(value = "name")
    private String name;

    @NotNull(message = "Тип параметра должен быть задан")
    @GridColumn(name = "type", label = "Тип", order = 2, cell = GridColumnType.string)
    @Column(value = "type")
    private Integer type = 0;

    @Column(value = "material_relation")
    //0 - only for materials, 1 - only for composite materials, 2 - for both material types
    private Integer materialRelation;

    @Override
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Integer getType() {
        return type;
    }

    public void setType(Integer type) {
        this.type = type;
    }

    public Integer getMaterialRelation() {
        return materialRelation;
    }

    public void setMaterialRelation(Integer materialRelation) {
        this.materialRelation = materialRelation;
    }
}
