package ru.crp.lvms.model.entities;

import ru.crp.cmlb.model.entities.Column;
import ru.crp.cmlb.model.entities.Table;
import ru.crp.cmlb.model.entities.base.Entity;
import ru.crp.cmlb.model.entities.base.Named;
import ru.crp.lvms.model.entities.tree.DefectNameEntity;
import ru.crp.lvms.validators.EntityExists;
import ru.crp.lvms.web.dto.columns.GridColumn;
import ru.crp.lvms.web.dto.columns.GridColumnType;

import javax.annotation.Nullable;
import javax.validation.constraints.NotNull;

@Table("possible_defects_join")
public class PossibleDefectsEntity implements Entity, Named {
    private int id;

    @Column("technology_id")
    private Integer technologyId;

    @GridColumn(name = "name", label = "Название", order = 1)
    @Column("defect_name")
    private String name;

    @GridColumn(name = "value", label = "Величина", order = 2)
    @Column("defect_value")
    @NotNull(message = "Значение должно быть задано")
    private String value;

    @GridColumn(name = "actName", label = "Название акта", cell = GridColumnType.uri, order = 3)
    @Column("act_name")
    @NotNull(message = "Название акта должно быть задано")
    private String actName;

    @Column("defect_name_id")
    @NotNull(message = "Название дефекта должно быть задано")
    @EntityExists(entityClass = DefectNameEntity.class, message = "Имя дефекта не найдено")
    private Integer defectNameId;

    @Column("defect_file_id")
    private Integer defectFileId;

    @Override
    public int getId() {
        return id;
    }

    @Override
    public void setId(int id) {
        this.id = id;
    }

    public Integer getTechnologyId() {
        return technologyId;
    }

    public void setTechnologyId(Integer technologyId) {
        this.technologyId = technologyId;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getValue() {
        return value;
    }

    public void setValue(String value) {
        this.value = value;
    }

    public String getActName() {
        return actName;
    }

    public void setActName(String actName) {
        this.actName = actName;
    }

    public Integer getDefectNameId() {
        return defectNameId;
    }

    public void setDefectNameId(Integer defectNameId) {
        this.defectNameId = defectNameId;
    }

    @Nullable
    public Integer getDefectFileId() {
        return defectFileId;
    }

    public void setDefectFileId(@Nullable Integer defectFileId) {
        this.defectFileId = defectFileId;
    }
}
