package ru.crp.lvms.model.entities;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonSetter;
import ru.crp.cmlb.model.entities.Column;
import ru.crp.cmlb.model.entities.Table;
import ru.crp.cmlb.model.entities.base.Entity;

import javax.annotation.Nullable;
import java.util.List;

@Table("unused")
public class ReferenceGraphEntry implements Entity {
    private int id;

//    for client side reference id means parent id
    @Nullable
    @Column("reference_id")
    @JsonProperty("pid")
    private Integer referenceId;

    @Column("name")
    private String name;

    @Nullable
    private List<ReferenceGraphEntry> children;

    private boolean isMainPath = false;

    private boolean isEntrance = false;

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    @Nullable
    public Integer getReferenceId() {
        return referenceId;
    }

    public void setReferenceId(@Nullable Integer referenceId) {
        this.referenceId = referenceId;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Nullable
    public List<ReferenceGraphEntry> getChildren() {
        return children;
    }

    public void setChildren(@Nullable List<ReferenceGraphEntry> children) {
        this.children = children;
    }

    public boolean isEntrance() {
        return isEntrance;
    }

    @JsonSetter("entrance")
    public void setIsEntrance(boolean isEntrance) {
        this.isEntrance = isEntrance;
    }

    public boolean isMainPath() {
        return isMainPath;
    }

    @JsonSetter("mainPath")
    public void setIsMainPath(boolean isMainPath) {
        this.isMainPath = isMainPath;
    }

    public boolean isRoot() {
        return referenceId == null;
    }
}
