package ru.crp.lvms.model.entities;

import ru.crp.cmlb.model.entities.Column;
import ru.crp.cmlb.model.entities.Table;
import ru.crp.cmlb.model.entities.base.Named;
import ru.crp.cmls.api.TaskParentType;
import ru.crp.cmls.calculations.solvers.xml.config.ResultType;
import ru.crp.lvms.model.entities.misc.AuditableImpl;
import ru.crp.lvms.model.entities.misc.CreatedBy;
import ru.crp.lvms.web.dto.columns.GridColumn;
import ru.crp.lvms.web.dto.columns.GridColumnType;

import javax.annotation.Nullable;

@Table("results_join")
public class ResultEntity extends AuditableImpl implements Named {

    @Column("parent_id")
    private Integer parentId;

    @Column("parent_type")
    private TaskParentType parentType;

    @Column("path_to_file")
    private String pathToFile;

    @GridColumn(name = "name", label = "Название", order = 0, cell = GridColumnType.uri)
    @Column("name")
    private String name;

    @Column("created_by")
    private CreatedBy createdBy;

    @GridColumn(name = "parentName", label = "Расчетный объект", cell = GridColumnType.uri, order = 2)
    @Column(value = "parent_name", onlySelect = true)
    private String parentName;

    @Column("type")
    private ResultType type;

    @GridColumn(name = "typeDisplayName", label = "Тип", order = 3)
    private String typeDisplayName;

    @GridColumn(name = "value", label = "Значение", order = 4)
    @Column(value = "value")
    private String value;

    @GridColumn(name = "targetValue", label = "Целевое значение", order = 5)
    @Column(value = "target_value")
    private String targetValue;

    @Column("description")
    private String description;

    @GridColumn(name = "hasPreview", label = "Просмотр", cell = GridColumnType.string, order = 6)
    private String hasPreview;

    @GridColumn(name = "owner", label = "Автор", cell = GridColumnType.uri, order = 102)
    @Column(value = "owner", onlySelect = true)
    private String owner;


    public Integer getParentId() {
        return parentId;
    }

    public void setParentId(Integer parentId) {
        this.parentId = parentId;
    }

    public TaskParentType getParentType() {
        return parentType;
    }

    public void setParentType(TaskParentType parentType) {
        this.parentType = parentType;
    }

    public String getPathToFile() {
        return pathToFile;
    }

    public void setPathToFile(String pathToFile) {
        this.pathToFile = pathToFile;
    }

    @Override
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public CreatedBy getCreatedBy() {
        return createdBy;
    }

    public void setCreatedBy(CreatedBy createdBy) {
        this.createdBy = createdBy;
    }

    public String getParentName() {
        return parentName;
    }

    public void setParentName(String parentName) {
        this.parentName = parentName;
    }

    public ResultType getType() {
        return type;
    }

    public void setType(@Nullable ResultType type) {
        this.type = type;
        if (type != null) {
            this.typeDisplayName = type.getDisplayName();
        }
        if (type == ResultType.pictures || type == ResultType.animations || type == ResultType.curves || type == ResultType.stlVisualisation) {
            this.hasPreview = String.valueOf(true);
        } else {
            this.hasPreview = String.valueOf(false);
        }
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getOwner() {
        return owner;
    }

    public void setOwner(String owner) {
        this.owner = owner;
    }

    public String getHasPreview() {
        return hasPreview;
    }

    public String getTypeDisplayName() {
        return typeDisplayName;
    }

    public void setTypeDisplayName(String typeDisplayName) {
        this.typeDisplayName = typeDisplayName;
    }

    public String getValue() {
        return value;
    }

    public void setValue(String value) {
        this.value = value;
    }

    public String getTargetValue() {
        return targetValue;
    }

    public void setTargetValue(String targetValue) {
        this.targetValue = targetValue;
    }

    public void setHasPreview(String hasPreview) {
        this.hasPreview = hasPreview;
    }
}
