package ru.crp.lvms.model.entities;

import ru.crp.cmlb.model.entities.Column;
import ru.crp.cmlb.model.entities.Table;
import ru.crp.cmlb.model.entities.base.Named;
import ru.crp.lvms.model.entities.misc.AuditableImpl;
import ru.crp.lvms.validators.Unique;

import javax.annotation.Nullable;
import javax.validation.constraints.NotNull;

@Unique(entityClass = StandardEntity.class, fieldName = "name", columnNane = "name",
        message = "Имя стандарта должно быть уникально")
@Table("standards_join")
public class StandardEntity extends AuditableImpl implements Named {
    private int id;

    @Column("name")
    @NotNull(message = "Имя стандарта должно быть задано")
    private String name;

    @Column("standard_file_id")
    private Integer standardFileId;

    @Column(value = "standard_file_name", onlySelect = true)
    private String standardFileName;

    @Column("load_file_id")
    private Integer loadFileId;

    @Column(value = "load_file_name", onlySelect = true)
    private String loadFileName;

    @Column(value = "owner", onlySelect = true)
    private String owner;

    @Column(value = "description")
    private String description;

    @Column(value = "creator")
    @NotNull(message = "Создатель стандарта должен быть задан")
    private String creator;

    @Override
    public int getId() {
        return id;
    }

    @Override
    public void setId(int id) {
        this.id = id;
    }

    @Override
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Integer getStandardFileId() {
        return standardFileId;
    }

    public void setStandardFileId(@Nullable Integer standardFileId) {
        this.standardFileId = standardFileId;
    }

    public String getStandardFileName() {
        return standardFileName;
    }

    public void setStandardFileName(String standardFileName) {
        this.standardFileName = standardFileName;
    }

    public Integer getLoadFileId() {
        return loadFileId;
    }

    public void setLoadFileId(@Nullable Integer loadFileId) {
        this.loadFileId = loadFileId;
    }

    public String getLoadFileName() {
        return loadFileName;
    }

    public void setLoadFileName(String loadFileName) {
        this.loadFileName = loadFileName;
    }

    public String getOwner() {
        return owner;
    }

    public void setOwner(String owner) {
        this.owner = owner;
    }

    public String getCreator() {
        return creator;
    }

    public void setCreator(String creator) {
        this.creator = creator;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(@Nullable String description) {
        this.description = description;
    }
}
