package ru.crp.lvms.model.entities;

import ru.crp.cmlb.model.entities.Column;
import ru.crp.cmlb.model.entities.Table;
import ru.crp.cmlb.model.entities.base.Entity;
import ru.crp.lvms.web.dto.columns.GridColumn;
import ru.crp.lvms.web.dto.columns.GridColumnType;

import javax.validation.constraints.NotNull;
import java.util.Date;

@Table("support_letters_join")
public class SupportLetterEntity implements Entity {
    private int id;

    @GridColumn(name = "content", label = "Текст сообщения", order = 4, cell = GridColumnType.string)
    @NotNull(message = "Введите текст сообщения")
    @Column("content")
    private String content;

    @Column("user_id")
    private Integer userId;

    @GridColumn(name = "userName", label = "Имя пользователя", order = 2, cell = GridColumnType.string)
    @Column(value = "user_name", onlySelect = true)
    private String userName;

    @GridColumn(name = "pageUrl", label = "Адрес страницы", order = 3, cell = GridColumnType.uri)
    @NotNull(message = "Адрес страницы не указан")
    @Column("page_url")
    private String pageUrl;

    @GridColumn(name = "creationDate", label = "Дата обращения", order = 1, cell = GridColumnType.date)
    @Column(value = "date_created", onlySelect = true)
    private Date creationDate;

    @GridColumn(name = "isProcessed", label = "Обработано", order = 5, cell = GridColumnType.bool)
    @Column("is_processed")
    private Boolean isProcessed;

    @Override
    public int getId() {
        return id;
    }

    @Override
    public void setId(int id) {
        this.id = id;
    }

    public String getContent() {
        return content;
    }

    public void setContent(String content) {
        this.content = content;
    }

    public Integer getUserId() {
        return userId;
    }

    public void setUserId(Integer userId) {
        this.userId = userId;
    }

    public String getPageUrl() {
        return pageUrl;
    }

    public void setPageUrl(String pageUrl) {
        this.pageUrl = pageUrl;
    }

    public Date getCreationDate() {
        return creationDate;
    }

    public void setCreationDate(Date creationDate) {
        this.creationDate = creationDate;
    }

    public Boolean getIsProcessed() {
        return isProcessed;
    }

    public void setIsProcessed(Boolean processed) {
        isProcessed = processed;
    }

    public String getUserName() {
        return userName;
    }

    public void setUserName(String userName) {
        this.userName = userName;
    }
}
