package ru.crp.lvms.model.entities.compositeMaterials;


import ru.crp.cmlb.model.entities.Column;
import ru.crp.cmlb.model.entities.Table;
import ru.crp.cmlb.model.entities.base.Named;
import ru.crp.lvms.model.entities.misc.BaseEntityTable;
import ru.crp.lvms.web.dto.columns.GridColumn;
import ru.crp.lvms.web.dto.columns.GridColumnType;

@Table("composite_materials")
public class CompositeMaterialEntityTable extends BaseEntityTable implements Named {
    @GridColumn(name = "name", label = "Название", order = 0, cell = GridColumnType.uri)
    @Column("name")
    private String name;

    @GridColumn(name = "manufacture", label = "Производитель", order = 1)
    @Column("manufacture")
    private String manufacture;

    @Column("pid")
    private Integer pid;

    @GridColumn(name = "source", label = "Данные", order = 2)
    @Column("source")
    private String source;

    @GridColumn(name = "description", label = "Описание", order = 3)
    @Column("description")
    private String description;

    @GridColumn(name = "lock", label = "Блок", order = 4)
    @Column("lock")
    private boolean lock;

    @Column("technology_id")
    private Integer technologyId;

    @Column("equipment_id")
    private Integer equipmentId;

    @Column("matrix_id")
    private Integer matrixId;

    @Column("fiber_id")
    private Integer fiberId;

    @Column("epoxide_id")
    private Integer epoxideId;

    @GridColumn(name = "fiberConcentration", label = "Концентрация волокон", cell = GridColumnType.string, order = 5)
    @Column("fiber_concentration")
    private Double fiberConcentration;

    @Column("symmetrical_layers")
    private boolean symmetricalLayers;

    @Override
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getManufacture() {
        return manufacture;
    }

    public void setManufacture(String manufacture) {
        this.manufacture = manufacture;
    }

    public Integer getPid() {
        return pid;
    }

    public void setPid(Integer pid) {
        this.pid = pid;
    }

    public String getSource() {
        return source;
    }

    public void setSource(String source) {
        this.source = source;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public boolean isLock() {
        return lock;
    }

    public void setLock(boolean lock) {
        this.lock = lock;
    }

    public Integer getTechnologyId() {
        return technologyId;
    }

    public void setTechnologyId(Integer technologyId) {
        this.technologyId = technologyId;
    }

    public Integer getEquipmentId() {
        return equipmentId;
    }

    public void setEquipmentId(Integer equipmentId) {
        this.equipmentId = equipmentId;
    }

    public Integer getMatrixId() {
        return matrixId;
    }

    public void setMatrixId(Integer matrixId) {
        this.matrixId = matrixId;
    }

    public Integer getFiberId() {
        return fiberId;
    }

    public void setFiberId(Integer fiberId) {
        this.fiberId = fiberId;
    }

    public boolean isSymmetricalLayers() {
        return symmetricalLayers;
    }

    public void setSymmetricalLayers(boolean symmetricalLayers) {
        this.symmetricalLayers = symmetricalLayers;
    }

    public Double getFiberConcentration() {
        return fiberConcentration;
    }

    public void setFiberConcentration(Double fiberConcentration) {
        this.fiberConcentration = fiberConcentration;
    }

    public Integer getEpoxideId() {
        return epoxideId;
    }

    public void setEpoxideId(Integer epoxideId) {
        this.epoxideId = epoxideId;
    }
}
