package ru.crp.lvms.model.entities.simulations;

import ru.crp.cmlb.model.entities.Column;
import ru.crp.cmlb.model.entities.Table;
import ru.crp.lvms.model.entities.tasks.TaskParent;
import ru.crp.lvms.web.dto.columns.GridColumn;
import ru.crp.lvms.web.dto.columns.GridColumnType;

import javax.annotation.Nullable;

@Table("virtual_simulations_join")
public class SimulationEntity extends SimulationEntityTable implements TaskParent {
    @GridColumn(name = "sampleFileName", label = "Файл образца", order = 1)
    @Column("sample_file_name")
    private String sampleFileName;

    @GridColumn(name = "standardName", label = "Стандарт", order = 2)
    @Column("standard_name")
    private String standardName;

    @GridColumn(name = "compositeMaterialName", label = "Композиционный материал", order = 3, cell = GridColumnType.uri)
    @Column("composite_material_name")
    private String compositeMaterialName;

    @GridColumn(name = "ecName", label = "Микроструктура", order = 4)
    @Column("ec_name")
    private String ecName;

    @Nullable
    @Column("experiment_results_file_name")
    private String experimentFileName;

    @Column("owner")
    private String owner;

    @Column(value = "results_count", onlySelect = true)
    private Integer resultsCount;

    private String type;

    private SolvingStatus status;


    @Override
    public void setStatusId(int statusId) {
        super.setStatusId(statusId);
        status = SolvingStatus.valueOf(statusId);
    }

    @Override
    public void setTypeId(int typeId) {
        super.setTypeId(typeId);
        type = SimulationType.valueOf(typeId).getDisplayName();
    }

    public String getSampleFileName() {
        return sampleFileName;
    }

    public void setSampleFileName(String sampleFileName) {
        this.sampleFileName = sampleFileName;
    }

    public String getStandardName() {
        return standardName;
    }

    public void setStandardName(String standardName) {
        this.standardName = standardName;
    }

    public String getCompositeMaterialName() {
        return compositeMaterialName;
    }

    public void setCompositeMaterialName(String compositeMaterialName) {
        this.compositeMaterialName = compositeMaterialName;
    }

    public String getOwner() {
        return owner;
    }

    public void setOwner(String owner) {
        this.owner = owner;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public SolvingStatus getStatus() {
        return status;
    }

    public void setStatus(SolvingStatus status) {
        this.status = status;
    }

    @Nullable
    public String getExperimentFileName() {
        return experimentFileName;
    }

    public void setExperimentFileName(@Nullable String experimentFileName) {
        this.experimentFileName = experimentFileName;
    }

    public String getEcName() {
        return ecName;
    }

    public void setEcName(String ecName) {
        this.ecName = ecName;
    }

    public Integer getResultsCount() {
        return resultsCount;
    }

    public void setResultsCount(Integer resultsCount) {
        this.resultsCount = resultsCount;
    }
}
