package ru.crp.lvms.model.entities.technology;

import ru.crp.cmlb.model.entities.Column;
import ru.crp.cmlb.model.entities.Table;
import ru.crp.cmlb.model.entities.base.Entity;
import ru.crp.cmlb.model.entities.base.Named;
import ru.crp.lvms.web.dto.columns.GridColumn;

import javax.validation.constraints.NotNull;

@Table("technology_parameters")
public class TechnologyParametersEntity implements Entity, Named {
    private int id;

    @Column("technology_id")
    private Integer technologyId;

    @GridColumn(name = "name", label = "Название", order = 1)
    @NotNull(message = "Название параметра должно быть задано")
    @Column("parameter_name")
    private String name;

    @GridColumn(name = "value", label = "Величина", order = 2)
    @NotNull(message = "Значение должно быть задано")
    @Column("parameter_value")
    private String value;

    @Override
    public int getId() {
        return id;
    }

    @Override
    public void setId(int id) {
        this.id = id;
    }

    public Integer getTechnologyId() {
        return technologyId;
    }

    public void setTechnologyId(Integer technologyId) {
        this.technologyId = technologyId;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getValue() {
        return value;
    }

    public void setValue(String value) {
        this.value = value;
    }
}
