package ru.crp.lvms.model.entities.technology;

import ru.crp.cmlb.model.entities.Column;
import ru.crp.cmlb.model.entities.Table;
import ru.crp.cmlb.model.entities.base.Named;
import ru.crp.lvms.managers.image.ImageFileContainer;
import ru.crp.lvms.model.entities.EquipmentEntity;
import ru.crp.lvms.model.entities.effective.characteristics.ECParamEntity;
import ru.crp.lvms.model.entities.misc.AuditableImpl;
import ru.crp.lvms.model.entities.simulations.SolvingStatus;
import ru.crp.lvms.validators.Unique;
import ru.crp.lvms.web.dto.columns.GridColumn;
import ru.crp.lvms.web.dto.columns.GridColumnType;

import static java.util.Collections.emptyList;

import javax.validation.constraints.NotNull;
import java.util.Collections;
import java.util.List;



@Table("technology_simulations_join")
public class TechnologySimulationsEntity extends AuditableImpl implements Named {

    @NotNull(message = "Технология должна быть задана")
    @Column("technology_id")
    private Integer technologyId;

    @NotNull(message = "Имя должно быть задано")
    @GridColumn(name = "name", label = "Название", cell = GridColumnType.uri, order = 1)
    @Column("name")
    private String name;

    @GridColumn(name = "description", label = "Описание", cell = GridColumnType.string, order = 2)
    @Column("description")
    private String description;

    @Column("status_id")
    private int statusId;


    @GridColumn(name = "owner", label = "Автор", cell = GridColumnType.uri, order = 3)
    @Column("owner")
    private String owner;


    private List<TechnologySimulationsRibsEntity> ribs = emptyList();

    private List<TechnologySimulationsParamEntity> params = emptyList();

    public List<TechnologySimulationsRibsEntity> getRibs() {
        return ribs;
    }

    public void setRibs(List<TechnologySimulationsRibsEntity> ribs) {
        this.ribs = ribs;
    }

//  private SolvingStatus status;

    public Integer getTechnologyId() {
        return technologyId;
    }

    public void setTechnologyId(Integer technologyId) {
        this.technologyId = technologyId;
    }

    @Override
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public int getStatusId() {
        return statusId;
    }

    public void setStatusId(int statusId) {
        this.statusId = statusId;
    }

    public String getOwner() {
        return owner;
    }

    public void setOwner(String owner) {
        this.owner = owner;
    }

    public List<TechnologySimulationsParamEntity> getParams() {
        return params;
    }

    public void setParams(List<TechnologySimulationsParamEntity> params) {
        this.params = params;
    }
}
