package ru.crp.lvms.model.entities.technology;

import com.fasterxml.jackson.annotation.JsonIgnore;
import ru.crp.cmlb.model.entities.Column;
import ru.crp.cmlb.model.entities.Table;
import ru.crp.cmlb.model.entities.base.Entity;
import ru.crp.lvms.web.dto.columns.GridColumn;

import javax.validation.constraints.NotNull;

@Table("technology_simulations_parameters_view")
public class TechnologySimulationsParamEntity implements Entity {

    private int id;

    @Column("technology_simulations_id")
    private Integer technologySimulationId;

    @NotNull(message = "Параметр должен быть задан")
    @Column("param_id")
    private Integer parameterId;

    @GridColumn(label = "Параметр", name = "parameterName", order = 1)
    @Column("param_name")
    private String parameterName;

    @GridColumn(label = "Значение", name = "parameterValue", order = 2)
    @Column("param_value")
    private String parameterValue;

    @Column("parent_param_id")
    private Integer parentParamId;

    @Column("parent_param_name")
    private String parentParamName;


    public TechnologySimulationsParamEntity() {
    }

    public TechnologySimulationsParamEntity(Integer technologySimulationsId, Integer parameterId) {
        this.technologySimulationId = technologySimulationsId;
        this.parameterId = parameterId;
    }




    public Integer getParameterId() {
        return parameterId;
    }

    public void setParameterId(Integer parameterId) {
        this.parameterId = parameterId;
    }

    public String getParameterName() {
        return parameterName;
    }

    public void setParameterName(String parameterName) {
        this.parameterName = parameterName;
    }

    public String getParameterValue() {
        return parameterValue;
    }

    public void setParameterValue(String parameterValue) {
        this.parameterValue = parameterValue;
    }

    @Override
    public int getId() {
        return id;
    }

    @Override
    public void setId(int id) {
        this.id = id;
    }

    public Integer getTechnologySimulationId() {
        return technologySimulationId;
    }

    public void setTechnologySimulationId(Integer technologySimulationId) {
        this.technologySimulationId = technologySimulationId;
    }

    public Integer getParentParamId() {
        return parentParamId;
    }

    public void setParentParamId(Integer parentParamId) {
        this.parentParamId = parentParamId;
    }

    public String getParentParamName() {
        return parentParamName;
    }

    public void setParentParamName(String parentParamName) {
        this.parentParamName = parentParamName;
    }
}
