package ru.crp.lvms.model.mappers;

import com.fasterxml.jackson.databind.ObjectMapper;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import ru.crp.lvms.model.entities.misc.PathEntry;

import javax.annotation.Nullable;
import java.beans.PropertyEditorSupport;
import java.io.IOException;
import java.util.Arrays;

public class PathPropertyEditor extends PropertyEditorSupport {
    private static final Logger LOGGER = LoggerFactory.getLogger(PathPropertyEditor.class);
    private ObjectMapper mapper;

    public PathPropertyEditor(ObjectMapper mapper) {
        this.mapper = mapper;
    }

    @Override
    public void setValue(Object value) {
        // expects that type of value is String and method setAsText will be called
        super.setValue(null);
    }

    @Override
    public void setAsText(@Nullable String text) {
        if (text != null) {
            try {
                String jsonArray = "[" + text + "]";
                PathEntry[] pathEntries = mapper.readValue(jsonArray, PathEntry[].class);
                super.setValue(Arrays.asList(pathEntries));
            } catch (IOException ex) {
                LOGGER.error("Unexpected field format: " + text, ex);
            }
        }
    }
}
