package ru.crp.lvms.optimizations.base.dao;

import org.springframework.stereotype.Repository;
import ru.crp.lvms.model.dao.BaseSpaceDao;
import ru.crp.lvms.optimizations.base.entities.OptimizationType;
import ru.crp.lvms.optimizations.base.enums.OptimizationTypes;

import javax.annotation.PostConstruct;

@Repository
public class OptimizationTypeDao extends BaseSpaceDao<OptimizationType> {

    @PostConstruct
    public void init() {
        getJdbcTemplate().query("SELECT id, unique_name, name FROM enabled_optimization_types", rs -> {
            int id = rs.getInt("id");
            String uniqueName = rs.getString("unique_name");
            String displayName = rs.getString("name");
            OptimizationTypes type = OptimizationTypes.fromUniqueName(uniqueName);
            type.setId(id);
            type.setDisplayName(displayName);
        });
    }
}
