package ru.crp.lvms.optimizations.base.entities;

import ru.crp.lvms.optimizations.base.enums.OptimizationCad;
import ru.crp.lvms.optimizations.base.enums.OptimizationCae;
import ru.crp.lvms.optimizations.base.enums.OptimizationCao;

import java.util.ArrayList;
import java.util.List;

import static java.util.stream.Collectors.toList;

public class CadWithCompatibles implements SolverWithCompatibles {

    private final String type = "CAD";

    private int id;

    private String name;

    private List<OptimizationCao> compatibleCAO;

    private List<OptimizationCae> compatibleCAE;

    public CadWithCompatibles() {
    }

    public CadWithCompatibles(int id, List<OptimizationTypeSolverCombination> combinations) {
        this.id = id;
        this.name = OptimizationCad.valueOf(id).name();
        this.compatibleCAO = combinations.stream()
                .map(OptimizationTypeSolverCombination::getCaoId)
                .filter(caoId -> caoId != null)
                .map(OptimizationCao::valueOf)
                .collect(toList());
        this.compatibleCAE = combinations.stream()
                .map(OptimizationTypeSolverCombination::getCaeId)
                .filter(caeId -> caeId != null)
                .map(OptimizationCae::valueOf)
                .collect(toList());
    }

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public List<OptimizationCao> getCompatibleCAD() {
        return compatibleCAO;
    }

    public void setCompatibleCAD(List<OptimizationCao> compatibleCAD) {
        this.compatibleCAO = new ArrayList<>(compatibleCAD);
    }

    public String getType() {
        return type;
    }

    public List<OptimizationCae> getCompatibleCAE() {
        return compatibleCAE;
    }

    public void setCompatibleCAE(List<OptimizationCae> compatibleCAE) {
        this.compatibleCAE = compatibleCAE;
    }
}
