package ru.crp.lvms.optimizations.base.entities;

import ru.crp.cmls.calculations.solvers.xml.config.ResultType;

import java.util.List;

public class OptimizationFlow {
    public static class BaseInfo {
        private Integer total;

        public BaseInfo(Integer total) {
            this.total = total;
        }

        public Integer getTotal() {
            return total;
        }
    }

    public static class ResultsInfo {
        private ResultType resultType;
        private Integer totalAuto;
        private Integer totalManual;

        public ResultsInfo(ResultType resultType, Integer totalAuto, Integer totalManual) {
            this.resultType = resultType;
            this.totalAuto = totalAuto;
            this.totalManual = totalManual;
        }

        public ResultType getResultType() {
            return resultType;
        }

        public Integer getTotalAuto() {
            return totalAuto;
        }

        public Integer getTotalManual() {
            return totalManual;
        }
    }

    public static class TotalResultsInfo {
        private List<ResultsInfo> resultsByType;
        private Integer totalAuto;
        private Integer totalManual;

        public TotalResultsInfo(List<ResultsInfo> resultsByType, Integer totalAuto, Integer totalManual) {
            this.resultsByType = resultsByType;
            this.totalAuto = totalAuto;
            this.totalManual = totalManual;
        }

        public List<ResultsInfo> getResultsByType() {
            return resultsByType;
        }

        public Integer getTotalAuto() {
            return totalAuto;
        }

        public Integer getTotalManual() {
            return totalManual;
        }
    }


    public OptimizationFlow() {
    }

    public OptimizationFlow(int optimizationId) {
        this.optimizationId = optimizationId;
    }

    private int optimizationId;
    private BaseInfo models;
    private BaseInfo technologies;
    private BaseInfo materials;
    private BaseInfo tasks;
    private TotalResultsInfo results;
    private BaseInfo files;
    private BaseInfo reports;
    private BaseInfo loadConditions;

    public BaseInfo getModels() {
        return models;
    }

    public void setModels(BaseInfo models) {
        this.models = models;
    }

    public BaseInfo getTasks() {
        return tasks;
    }

    public void setTasks(BaseInfo tasks) {
        this.tasks = tasks;
    }

    public TotalResultsInfo getResults() {
        return results;
    }

    public void setResults(TotalResultsInfo results) {
        this.results = results;
    }

    public BaseInfo getFiles() {
        return files;
    }

    public void setFiles(BaseInfo files) {
        this.files = files;
    }

    public BaseInfo getReports() {
        return reports;
    }

    public void setReports(BaseInfo reports) {
        this.reports = reports;
    }

    public int getOptimizationId() {
        return optimizationId;
    }

    public void setOptimizationId(int optimizationId) {
        this.optimizationId = optimizationId;
    }

    public BaseInfo getTechnologies() {
        return technologies;
    }

    public void setTechnologies(BaseInfo technologies) {
        this.technologies = technologies;
    }

    public BaseInfo getMaterials() {
        return materials;
    }

    public void setMaterials(BaseInfo materials) {
        this.materials = materials;
    }

    public BaseInfo getLoadConditions() {
        return loadConditions;
    }

    public void setLoadConditions(BaseInfo loadConditions) {
        this.loadConditions = loadConditions;
    }
}
