package ru.crp.lvms.optimizations.base.entities;

import ru.crp.cmlb.model.entities.Column;
import ru.crp.cmlb.model.entities.Table;
import ru.crp.cmlb.model.entities.base.Entity;
import ru.crp.cmlb.model.entities.base.Named;
import ru.crp.lvms.model.entities.misc.CreatedBy;
import ru.crp.lvms.web.dto.columns.GridColumn;

import java.util.Date;

@Table("optimization_reports")
public class OptimizationReportEntity implements Entity, Named {
    private int id;

    @GridColumn(name = "name", label = "Название", order = 0)
    @Column("name")
    private String name;

    @GridColumn(name = "createdBy", label = "Создано", order = 1)
    @Column("created_by")
    private CreatedBy createdBy;

    @Column("optimization_id")
    private Integer optimizationId;

    @Column("owner_id")
    private Integer ownerId;

    @GridColumn(name = "dateCreated", label = "Создано", order = 4)
    @Column(value = "date_created", onlySelect = true)
    private Date dateCreated;

    @Override
    public int getId() {
        return id;
    }

    @Override
    public void setId(int id) {
        this.id = id;
    }

    public CreatedBy getCreatedBy() {
        return createdBy;
    }

    public void setCreatedBy(CreatedBy createdBy) {
        this.createdBy = createdBy;
    }

    public Integer getOptimizationId() {
        return optimizationId;
    }

    public void setOptimizationId(Integer optimizationId) {
        this.optimizationId = optimizationId;
    }

    @Override
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Integer getOwnerId() {
        return ownerId;
    }

    public void setOwnerId(Integer ownerId) {
        this.ownerId = ownerId;
    }

    public Date getDateCreated() {
        return dateCreated;
    }

    public void setDateCreated(Date dateCreated) {
        this.dateCreated = dateCreated;
    }
}
