package ru.crp.lvms.optimizations.base.mappers;

import org.springframework.jdbc.core.RowMapper;
import ru.crp.cmls.calculations.solvers.xml.config.ResultType;
import ru.crp.lvms.optimizations.base.entities.OptimizationFlow;

import java.sql.ResultSet;
import java.sql.SQLException;

public class OptimizationFlowResultRowMapper implements RowMapper<OptimizationFlow.ResultsInfo> {

    @Override
    public OptimizationFlow.ResultsInfo mapRow(ResultSet rs, int rowNum) throws SQLException {
        ResultType resultType = ResultType.valueOf(rs.getString("type"));
        int totalBench = rs.getInt("total_auto");
        int totalManual = rs.getInt("total_manual");
        return new OptimizationFlow.ResultsInfo(resultType, totalBench, totalManual);
    }
}
