package ru.crp.lvms.optimizations.base.mappers;

import org.springframework.jdbc.core.RowMapper;
import ru.crp.lvms.optimizations.base.entities.OptimizationFlow;

import java.sql.ResultSet;
import java.sql.SQLException;

public class OptimizationFlowRowMapper implements RowMapper<OptimizationFlow> {
    @Override
    public OptimizationFlow mapRow(ResultSet rs, int rowNum) throws SQLException {
        OptimizationFlow result = new OptimizationFlow();
        result.setOptimizationId(rs.getInt("optimization_id"));
        result.setReports(new OptimizationFlow.BaseInfo(rs.getInt("total_reports")));
        result.setTasks((new OptimizationFlow.BaseInfo(rs.getInt("total_tasks"))));
        result.setModels(new OptimizationFlow.BaseInfo(rs.getInt("total_models")));
        result.setMaterials(new OptimizationFlow.BaseInfo(rs.getInt("total_materials")));
        result.setTechnologies(new OptimizationFlow.BaseInfo(rs.getInt("total_technologies")));
        result.setLoadConditions(new OptimizationFlow.BaseInfo(rs.getInt("total_load_conditions")));
        return result;
    }
}
