package ru.crp.lvms.optimizations.mf.dao;

import org.springframework.stereotype.Repository;
import ru.crp.lvms.optimizations.mf.entities.MFOptimizationVaryingParam;
import ru.crp.lvms.optimizations.misc.AbstractOptimizationSettignsDao;

import java.util.List;

@Repository
public class MFOptimizationVaryingParamsDao extends AbstractOptimizationSettignsDao<MFOptimizationVaryingParam> {

    public void unselectParams(int optimizationId) {
        jdbcTemplate().update("UPDATE optimization_varying_params_join SET is_used_in_script = FALSE WHERE optimization_id = ?",
                optimizationId);
    }

    public void selectVaryingParam(Integer optimizationId, Integer paramId) {
        jdbcTemplate().update("UPDATE optimization_varying_params_join SET is_used_in_script = TRUE" +
                " WHERE optimization_id = ? AND id = ?", optimizationId, paramId);
    }

    @Override
    public List<MFOptimizationVaryingParam> findForOptimization(int optimizationId) {
        return find("WHERE optimization_id = ? ORDER BY id", optimizationId);
    }
}
