package ru.crp.lvms.optimizations.mf.enums;

import ru.crp.lvms.optimizations.base.enums.BaseSetting;

import javax.annotation.Nonnull;

public enum MFBaseSettingType implements BaseSetting {
    NUM_TARGET_FUNCS(1),
    NUM_CAO_VARYING_PARAMS(2),
    NUM_OUTPUT_PARAMS(3),
    NUM_CONSTRAINTS(4),
    NUM_CAD_VARYING_PARAMS(5);

    private int id;
    private int maxValue;
    private int minValue;
    private String displayName;

    MFBaseSettingType(int id) {
        this.id = id;
    }

    @Nonnull
    public static MFBaseSettingType valueOf(int id) {
        for (MFBaseSettingType cur : values()) {
            if (cur.getId() == id) {
                return cur;
            }
        }
        throw new IllegalArgumentException("Enum value for id " + id + " is not found");
    }

    public int getId() {
        return id;
    }

    public int getMaxValue() {
        return maxValue;
    }

    public void setMaxValue(int maxValue) {
        this.maxValue = maxValue;
    }

    public String getDisplayName() {
        return displayName;
    }

    public void setDisplayName(String displayName) {
        this.displayName = displayName;
    }

    public int getMinValue() {
        return minValue;
    }

    public void setMinValue(int minValue) {
        this.minValue = minValue;
    }
}
