package ru.crp.lvms.optimizations.mf.enums;

import javax.annotation.Nonnull;

public enum MFTargetFuncsType {
    NONE(1, ""),
    MIN(2, "-1"),
    MAX(3, "1");

    private String xmlValue;
    private int id;

    MFTargetFuncsType(int id, String xmlValue) {
        this.xmlValue = xmlValue;
        this.id = id;
    }

    public String getXmlValue() {
        return xmlValue;
    }

    public int getId() {
        return id;
    }

    @Nonnull
    public static MFTargetFuncsType valueOf(int id) {
        for (MFTargetFuncsType type : values()) {
            if (type.getId() == id) {
                return type;
            }
        }
        throw new IllegalArgumentException("Enum value for id " + id + " is not found");
    }

}
