package ru.crp.lvms.optimizations.optimus.controllers;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import ru.crp.lvms.optimizations.base.enums.OptimizationCao;
import ru.crp.lvms.optimizations.misc.AbstractOptimizationSettingsController;
import ru.crp.lvms.optimizations.misc.AbstractOptimizationSettingsManager;
import ru.crp.lvms.optimizations.optimus.entities.OptimusOptimizationConstraint;
import ru.crp.lvms.optimizations.optimus.enums.OptimusBaseSettingType;
import ru.crp.lvms.optimizations.optimus.enums.OptimusSettingsType;
import ru.crp.lvms.optimizations.optimus.managers.OptimusOptimizationSettingsManager;

import static ru.crp.lvms.utils.URLs.OPTIMUS_CONSTRAIN_URL;

@RestController
@RequestMapping(value = OPTIMUS_CONSTRAIN_URL, produces = MediaType.APPLICATION_JSON_VALUE)
public class OptimusConstraintController extends AbstractOptimizationSettingsController<OptimusOptimizationConstraint, OptimusSettingsType> {

    @Autowired
    private OptimusOptimizationSettingsManager optimusOptimizationSettingsManager;

    @Override
    protected OptimusSettingsType getSettingsType() {
        return OptimusSettingsType.Constraint;
    }

    @Override
    protected AbstractOptimizationSettingsManager<OptimusSettingsType> getSettingsManager() {
        return optimusOptimizationSettingsManager;
    }

    @Override
    protected OptimizationCao getOptimizationSolverType() {
        return OptimizationCao.Optimus;
    }

    @Override
    protected Integer getSettingsCount(int optimizationId) {
        return optimusOptimizationSettingsManager
                .getBaseSettingsByType(optimizationId, OptimusBaseSettingType.NUM_CONSTRAINTS)
                .getCurrentValue();
    }
}
