package ru.crp.lvms.optimizations.optimus.entities;

import ru.crp.cmlb.model.entities.Column;
import ru.crp.cmlb.model.entities.Table;
import ru.crp.lvms.optimizations.mf.enums.MFBaseSettingType;
import ru.crp.lvms.optimizations.misc.AbstractOptimizationSettings;
import ru.crp.lvms.optimizations.optimus.enums.OptimusBaseSettingType;

import javax.annotation.Nullable;

@Table("optimus_optimization_base_settings_join")
public class OptimusOptimizationBaseSetting extends AbstractOptimizationSettings {
    @Nullable
    @Column("current_value")
    private Integer currentValue;

    @Column(value = "max_value", onlySelect = true)
    private Integer maxValue;

    @Column(value = "min_value", onlySelect = true)
    private Integer minValue;

    @Column(value = "type_id")
    private int typeId;

    public OptimusOptimizationBaseSetting() {
    }

    public OptimusOptimizationBaseSetting(int optimizationId, int typeId, int currentValue) {
        setOptimizationId(optimizationId);
        this.typeId = typeId;
        this.currentValue = currentValue;
    }

    @Nullable
    public Integer getCurrentValue() {
        return currentValue;
    }

    public void setCurrentValue(@Nullable Integer currentValue) {
        this.currentValue = currentValue;
    }

    public Integer getMaxValue() {
        return maxValue;
    }

    public void setMaxValue(Integer maxValue) {
        this.maxValue = maxValue;
    }

    public int getTypeId() {
        return typeId;
    }

    public void setTypeId(int typeId) {
        this.typeId = typeId;
    }

    public String getType() {
        return OptimusBaseSettingType.valueOf(typeId).name();
    }

    //for json deserialization
    public void setType(String unused) {

    }

    public Integer getMinValue() {
        return minValue;
    }

    public void setMinValue(Integer minValue) {
        this.minValue = minValue;
    }
}
