package ru.crp.lvms.optimizations.optistruct.controllers;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import ru.crp.lvms.optimizations.base.dao.OptimizationJsonSettingsDao;
import ru.crp.lvms.optimizations.base.enums.OptimizationCao;
import ru.crp.lvms.optimizations.misc.AbstractOptimizationSettingsController;
import ru.crp.lvms.optimizations.optistruct.entities.OptistructOptimizationBaseSetting;
import ru.crp.lvms.optimizations.optistruct.enums.OptistructBaseSettingType;
import ru.crp.lvms.optimizations.optistruct.enums.OptistructSettingsType;
import ru.crp.lvms.optimizations.optistruct.managers.OptistructOptimizationSettingsManager;
import ru.crp.lvms.utils.URLs;

@RestController
@RequestMapping(value = URLs.OPTISTRUCT_BASE_SETTINGS_URL, produces = MediaType.APPLICATION_JSON_VALUE)
public class OptistructBaseSettingsController extends AbstractOptimizationSettingsController<OptistructOptimizationBaseSetting, OptistructSettingsType> {

    @Autowired
    private OptistructOptimizationSettingsManager optistructOptimizationSettingsManager;

    @Autowired
    private OptimizationJsonSettingsDao optimizationJsonSettingsDao;


    @Override
    protected OptistructSettingsType getSettingsType() {
        return OptistructSettingsType.BaseSetting;
    }

    @Override
    protected Integer getSettingsCount(int optimizationId) {
        return OptistructBaseSettingType.values().length;
    }

    @Override
    protected OptistructOptimizationSettingsManager getSettingsManager() {
        return optistructOptimizationSettingsManager;
    }

    @Override
    protected OptimizationCao getOptimizationSolverType() {
        return OptimizationCao.Optistruct;
    }
}
