package ru.crp.lvms.optimizations.optistruct.controllers;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;
import ru.crp.lvms.optimizations.base.entities.OptimizationJsonSetting;
import ru.crp.lvms.optimizations.optistruct.managers.OptistructAdditionalParametersManager;

import javax.validation.Valid;
import java.util.List;

import static ru.crp.lvms.optimizations.optistruct.managers.OptistructAdditionalParametersManager.POSTPROCESSING;
import static ru.crp.lvms.utils.URLs.OPTISTRUCT_POSTPROCESSING_PARAMETERS_URL;

@RestController
@RequestMapping(value = OPTISTRUCT_POSTPROCESSING_PARAMETERS_URL, produces = MediaType.APPLICATION_JSON_VALUE)
public class OptistructPostprocessingParametersController {

    @Autowired
    private OptistructAdditionalParametersManager optistructAdditionalParametersManager;

    @RequestMapping(method = RequestMethod.GET)
    public List<OptimizationJsonSetting> getAdditionalParameters(@PathVariable("optimizationId") int optimizationId) {
        return optistructAdditionalParametersManager.getAdditionalParameters(optimizationId, POSTPROCESSING);
    }

    @PreAuthorize("hasRole('ROLE_USER')")
    @RequestMapping(value ="/{apId}", method = RequestMethod.PUT)
    public OptimizationJsonSetting updateAdditionalParameter(@Valid @RequestBody OptimizationJsonSetting updated,
                                                             @PathVariable("optimizationId") int optimizationId,
                                                             @PathVariable int apId) {
        return optistructAdditionalParametersManager.updateAdditionalParameter(updated, optimizationId, apId, POSTPROCESSING);
    }
}
