package ru.crp.lvms.optimizations.optistruct.entities;

import com.fasterxml.jackson.annotation.JsonIgnore;
import ru.crp.cmlb.model.entities.Column;
import ru.crp.cmlb.model.entities.Table;
import ru.crp.cmlb.model.entities.base.Entity;

@Table("optistruct_optimization_collectors")
public class OptistructCollector implements Entity {
    private int id;

    @Column("optimization_id")
    private Integer optimizationId;

    @JsonIgnore
    @Column("script_id")
    private Integer scriptId;

    @Column("name")
    private String name;

    @JsonIgnore
    @Column("data_type")
    private String dataType;

    public OptistructCollector() {
    }

    public OptistructCollector(Integer optimizationId, Integer scriptId, String name) {
        this.optimizationId = optimizationId;
        this.scriptId = scriptId;
        this.name = name;
    }

    public OptistructCollector(Integer optimizationId, Integer scriptId, String name, String dataType) {
        this.optimizationId = optimizationId;
        this.scriptId = scriptId;
        this.name = name;
        this.dataType = dataType;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        OptistructCollector that = (OptistructCollector) o;

        if (getOptimizationId() != null ? !getOptimizationId().equals(that.getOptimizationId()) : that.getOptimizationId() != null)
            return false;
        if (getScriptId() != null ? !getScriptId().equals(that.getScriptId()) : that.getScriptId() != null)
            return false;
        if (getName() != null ? !getName().equals(that.getName()) : that.getName() != null) return false;
        return getDataType() != null ? getDataType().equals(that.getDataType()) : that.getDataType() == null;

    }

    @Override
    public int hashCode() {
        int result = getOptimizationId() != null ? getOptimizationId().hashCode() : 0;
        result = 31 * result + (getScriptId() != null ? getScriptId().hashCode() : 0);
        result = 31 * result + (getName() != null ? getName().hashCode() : 0);
        result = 31 * result + (getDataType() != null ? getDataType().hashCode() : 0);
        return result;
    }

    @Override
    public int getId() {
        return id;
    }

    @Override
    public void setId(int id) {
        this.id = id;
    }

    public Integer getScriptId() {
        return scriptId;
    }

    public void setScriptId(Integer scriptId) {
        this.scriptId = scriptId;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getDataType() {
        return dataType;
    }

    public void setDataType(String dataType) {
        this.dataType = dataType;
    }

    public Integer getOptimizationId() {
        return optimizationId;
    }

    public void setOptimizationId(Integer optimizationId) {
        this.optimizationId = optimizationId;
    }
}
