package ru.crp.lvms.optimizations.optistruct.enums;

import com.fasterxml.jackson.annotation.JsonFormat;

import javax.annotation.Nonnull;


@JsonFormat(shape = JsonFormat.Shape.OBJECT)
public enum LnSetType {
    nodes(1),
    elems(2);

    private int id;

    LnSetType(int id) {
        this.id = id;
    }

    @Nonnull
    public static LnSetType valueOf(int id) {
        for (LnSetType cur : values()) {
            if (cur.getId() == id) {
                return cur;
            }
        }
        throw new IllegalArgumentException("Enum value for id " + id + " is not found");
    }

    public int getId() {
        return id;
    }

    public String getName() {
        return this.toString();
    }
}
