package ru.crp.lvms.optimizations.tosca.config.argumentConverters;

import org.apache.commons.lang3.tuple.Pair;
import ru.crp.lvms.optimizations.base.entities.tree.TechnologicalConstraintTreeNodeValue;
import ru.crp.lvms.optimizations.tosca.entities.ToscaOptimizationTechnologicalConstraint;
import ru.crp.lvms.optimizations.base.entities.tree.TechnologicalConstraintTreeNode;
import ru.crp.lvms.optimizations.tosca.managers.ToscaOptimizationTechnologicalConstraintManager;

import java.util.ArrayList;
import java.util.List;

abstract public class CommandArgumentConverter {
    protected ToscaOptimizationTechnologicalConstraintManager toscaOptimizationTechnologicalConstraintManager;

    public CommandArgumentConverter(ToscaOptimizationTechnologicalConstraintManager toscaOptimizationTechnologicalConstraintManager) {
        this.toscaOptimizationTechnologicalConstraintManager = toscaOptimizationTechnologicalConstraintManager;
    }

    abstract public List<Pair<String, String>> convertValue(ToscaOptimizationTechnologicalConstraint constraint, TechnologicalConstraintTreeNodeValue value,
                                                      List<TechnologicalConstraintTreeNodeValue> allValues,
                                                      List<Pair<String, String>> alreadyConvertedValues);

    abstract public boolean canConvert(ToscaOptimizationTechnologicalConstraint constraint, TechnologicalConstraintTreeNodeValue value);

    protected List<TechnologicalConstraintTreeNode> getAscendingBranch(TechnologicalConstraintTreeNodeValue initial) {
        List<TechnologicalConstraintTreeNode> branch = new ArrayList<>();
        branch.add(initial);
        TechnologicalConstraintTreeNode current = initial;
        while (current.getParentId() != null) {
            current = toscaOptimizationTechnologicalConstraintManager.getField(current.getParentId());
            branch.add(current);
        }
        return branch;
    }
}
