package ru.crp.lvms.optimizations.tosca.config.commandConverters;

import org.apache.commons.lang3.tuple.Pair;
import ru.crp.lvms.optimizations.base.entities.tree.TechnologicalConstraintTreeNodeValue;
import ru.crp.lvms.optimizations.tosca.config.Command;
import ru.crp.lvms.optimizations.tosca.config.OptimizationTypeParameters;
import ru.crp.lvms.optimizations.tosca.entities.ToscaOptimizationTechnologicalConstraint;
import ru.crp.lvms.optimizations.tosca.managers.ToscaOptimizationTechnologicalConstraintManager;

import java.util.List;
import java.util.stream.Stream;

public class DefaultCommandConverter extends CommandConverter {
    public DefaultCommandConverter(ToscaOptimizationTechnologicalConstraintManager toscaOptimizationTechnologicalConstraintManager) {
        super(toscaOptimizationTechnologicalConstraintManager);
    }

    @Override
    public Stream<Command> convert(OptimizationTypeParameters typeParameters, ToscaOptimizationTechnologicalConstraint tc, Integer index,
                                   String space, List<TechnologicalConstraintTreeNodeValue> values) {
        List<Pair<String, String>> commandArguments = convertTCValues(tc, values);
        Command dvconCommand = createDvConCommand(typeParameters, tc, index)
                .addParameter(typeParameters.getGroupName(), space)
                .addParameters(commandArguments);
        return Stream.of(dvconCommand);
    }


    @Override
    public boolean canConvert(ToscaOptimizationTechnologicalConstraint tc) {
        return true;
    }
}
