package ru.crp.lvms.optimizations.tosca.controllers;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import ru.crp.lvms.optimizations.base.dao.OptimizationJsonSettingsDao;
import ru.crp.lvms.optimizations.base.enums.OptimizationCao;
import ru.crp.lvms.optimizations.misc.AbstractOptimizationSettingsController;
import ru.crp.lvms.optimizations.tosca.entities.ToscaOptimizationBaseSetting;
import ru.crp.lvms.optimizations.tosca.enums.ToscaBaseSettingType;
import ru.crp.lvms.optimizations.tosca.enums.ToscaSettingsType;
import ru.crp.lvms.optimizations.tosca.managers.ToscaOptimizationSettingsManager;
import ru.crp.lvms.utils.URLs;

@RestController
@RequestMapping(value = URLs.TOSCA_BASE_SETTINGS_URL, produces = MediaType.APPLICATION_JSON_VALUE)
public class ToscaBaseSettingsController extends AbstractOptimizationSettingsController<ToscaOptimizationBaseSetting, ToscaSettingsType> {

    @Autowired
    private ToscaOptimizationSettingsManager toscaOptimizationSettingsManager;

    @Autowired
    private OptimizationJsonSettingsDao optimizationJsonSettingsDao;


    @Override
    protected ToscaSettingsType getSettingsType() {
        return ToscaSettingsType.BaseSetting;
    }

    @Override
    protected Integer getSettingsCount(int optimizationId) {
        return ToscaBaseSettingType.values().length;
    }

    @Override
    protected ToscaOptimizationSettingsManager getSettingsManager() {
        return toscaOptimizationSettingsManager;
    }

    @Override
    protected OptimizationCao getOptimizationSolverType() {
        return OptimizationCao.Tosca;
    }
}
