package ru.crp.lvms.optimizations.tosca.dao;

import org.springframework.stereotype.Repository;
import ru.crp.lvms.model.dao.BaseSpaceDao;
import ru.crp.lvms.optimizations.tosca.entities.ToscaTargetFuncOrConstraintParameter;

import java.util.List;

@Repository
public class ToscaTargetFunctionParametersDao extends BaseSpaceDao<ToscaTargetFuncOrConstraintParameter> {

    public List<ToscaTargetFuncOrConstraintParameter> findAllowed(Integer optimizationId, boolean isForTF) {
        String availabilityField;
        if (isForTF) {
            availabilityField = "is_tf";
        } else {
            availabilityField = "is_costraint";
        }
        return find("JOIN toska_optimization_type_tf tott ON t.id = tott.parameter_id " +
                "JOIN optimizations o ON o.optimization_type_id = tott.opt_type_id " +
                "WHERE " + availabilityField + " = TRUE AND o.id = ?", optimizationId);
    }
}
