package ru.crp.lvms.optimizations.tosca.enums;

import com.fasterxml.jackson.annotation.JsonFormat;

import javax.annotation.Nonnull;

/* Used in constraints */
@JsonFormat(shape = JsonFormat.Shape.OBJECT)
public enum ToscaConstraintType {
    EQUALS(1, "="),
    LESS_OR_EQUAL(2, "≤"),
    GREATER_OR_EQUAL(3, "≥");

    private Integer id;
    private String name;

    ToscaConstraintType(Integer id, String name) {
        this.id = id;
        this.name = name;
    }

    public Integer getId() {
        return id;
    }

    public String getName() {
        return name;
    }

    @Nonnull
    public static ToscaConstraintType valueOf(int id) {
        for (ToscaConstraintType cur : values()) {
            if (cur.getId() == id) {
                return cur;
            }
        }
        throw new IllegalArgumentException("Enum value for id " + id + " is not found");
    }
}
