package ru.crp.lvms.optimizations.tosca.enums;

import com.fasterxml.jackson.annotation.JsonFormat;

import javax.annotation.Nonnull;

/* Used in target functions */
@JsonFormat(shape = JsonFormat.Shape.OBJECT)
public enum ToscaTargetFunctionType {
    MIN(1, "MIN"),
    MAX(2, "MAX"),
    MINMAX(3, "MINMAX");

    private Integer id;
    private String name;

    ToscaTargetFunctionType(Integer id, String name) {
        this.id = id;
        this.name = name;
    }

    public Integer getId() {
        return id;
    }

    public String getName() {
        return name;
    }

    @Nonnull
    public static ToscaTargetFunctionType valueOf(int id) {
        for (ToscaTargetFunctionType cur : values()) {
            if (cur.getId() == id) {
                return cur;
            }
        }
        throw new IllegalArgumentException("Enum value for id " + id + " is not found");
    }
}
