package ru.crp.lvms.security;

import com.fasterxml.jackson.databind.ObjectMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.Authentication;
import org.springframework.security.web.authentication.AuthenticationSuccessHandler;
import org.springframework.stereotype.Component;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashMap;
import java.util.Map;


@Component("authenticationSuccessHandler")
public class SecurityAuthenticationSuccessHandler implements AuthenticationSuccessHandler {

    @Autowired
    private ObjectMapper jacksonMapper;

    @Override
    public void onAuthenticationSuccess(HttpServletRequest request, HttpServletResponse response, Authentication auth)
            throws IOException, ServletException {
        PortalUser user = (PortalUser) auth.getPrincipal();

        Map<String, Object> result = new HashMap<>();
        result.put("id", user.getUser().getId());
        result.put("login", user.getUser().getLogin());
        result.put("name", user.getUser().getName());
        result.put("role", user.getUser().getRole());
        response.setCharacterEncoding("utf-8");
        PrintWriter out = response.getWriter();
        out.write(jacksonMapper.writeValueAsString(result));
        out.flush();
    }
}
