package ru.crp.lvms.tasks;

import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;
import ru.crp.cmlb.model.entities.CalculationStatus;
import ru.crp.lvms.cluster.model.ClusterEntity;
import ru.crp.lvms.model.entities.tasks.TaskEntity;
import ru.crp.lvms.tasks.misc.BaseTasksJob;
import ru.crp.lvms.tasks.misc.ClusterCommandsManager;

import java.util.List;


@Component("downloadTasksResultsJob")
public class DownloadTaskResultsJob extends BaseTasksJob {

    @Override
    @Transactional(readOnly = true)
    public List<TaskEntity> getTasksToCheck() {
        return taskDao.findComplete();
    }

    @Override
    public void checkTask(TaskEntity finishedTask, ClusterEntity taskCluster, ClusterCommandsManager clusterCommandManager) throws Exception {
        if (!clusterCommandManager.isTaskReadyForDownloadResults(finishedTask, taskCluster)) {
            return;
        }
        taskStatusUpdater.changeTaskStatus(finishedTask, CalculationStatus.ImportingResults);
        clusterCommandManager.downloadResultsForTask(finishedTask);
    }
}
