package ru.crp.lvms.tasks.misc;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import ru.crp.lvms.cluster.ClustersManager;
import ru.crp.lvms.managers.NodesManager;
import ru.crp.lvms.managers.SimulationManager;
import ru.crp.lvms.managers.solvers.SolverConnectionManager;
import ru.crp.lvms.managers.tasks.TaskStatusUpdater;
import ru.crp.lvms.model.entities.tasks.TaskEntity;


abstract public class CommandCallbackHelper {
    private static final Logger LOGGER = LoggerFactory.getLogger(CommandCallbackHelper.class);

    @Autowired
    protected NodesManager nodesManager;

    @Autowired
    protected SolverConnectionManager solverConnectionManager;

    @Autowired
    protected SimulationManager simulationManager;

    @Autowired
    protected TaskStatusUpdater taskStatusUpdater;

    @Autowired
    protected ClustersManager clustersManager;

    // WARN! For now consider only space nodes, not slurm
    protected boolean checkNodeAlive(TaskEntity finishedTask) {
        if (finishedTask.getNodeId() == null) {
            LOGGER.error("Found task in running state but without node. Task id = {}", finishedTask.getId());
            return false;
        }
        return nodesManager.getNodeAliveStatus(finishedTask.getNodeId());
    }
}
