package ru.crp.lvms.tasks.slurm.requests;


import ru.crp.lvms.tasks.slurm.SlurmNodeInfo;
import ru.crp.lvms.tasks.slurm.SlurmNodeInfoMapper;

import java.util.List;
import java.util.stream.Stream;

import static java.util.stream.Collectors.toList;

public class PartitionNodesRequest extends AbstractRequest<List<SlurmNodeInfo>> {
    private String partitionName;

    public PartitionNodesRequest(String partitionName) {
        this.partitionName = partitionName;
    }

    @Override
    public String getCommandLine() {
        return String.format("sinfo --partition=%s --Format=%s", partitionName, SlurmNodeInfoMapper.NODES_INFO_FORMAT);
    }

    @Override
    public List<SlurmNodeInfo> parseResponse(String response) {
        return Stream.of(response.split("\n"))
                .skip(1)
                .map(SlurmNodeInfoMapper::parseInfo)
                .collect(toList());
    }
}
