package ru.crp.lvms.web.controllers.misc;

import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseStatus;
import ru.crp.lvms.managers.misc.PreferencesManager;
import ru.crp.lvms.security.CurrentUser;
import ru.crp.lvms.security.PortalUser;
import ru.crp.lvms.web.dto.columns.FieldMapping;

import javax.validation.Valid;
import java.io.IOException;
import java.util.List;

public interface ColumnsController {

    @RequestMapping(value = "/columns", method = RequestMethod.GET)
    //@Transactional(readOnly = true)
    default List<FieldMapping> getColumns(@CurrentUser PortalUser currentUser) {
        return getPreferencesManager().getAllPrefsForTable(currentUser.getUser(), getOutVoClass());
    }

    @RequestMapping(value = "/columns", method = RequestMethod.DELETE)
    default List<FieldMapping> resetColumns(@CurrentUser PortalUser currentUser) throws IOException {
        getPreferencesManager().restoreAllColumns(currentUser.getUser().getId(), getOutVoClass());
        return getColumns(currentUser);
    }

    @RequestMapping(value = "/columns/order", method = RequestMethod.PUT)
    @ResponseStatus(HttpStatus.OK)
    default void setColumnsOrder(@CurrentUser PortalUser currentUser, @RequestBody List<String> columnNames) {
        getPreferencesManager().changeColumnsOrder(currentUser.getUser().getId(), getOutVoClass(), columnNames);
    }

    @RequestMapping(value = "/columns", method = RequestMethod.PUT)
    @ResponseStatus(HttpStatus.OK)
    default void changeColumnPrefs(@CurrentUser PortalUser currentUser, @Valid @RequestBody FieldMapping mappingToChange)
            throws IOException {
        getPreferencesManager().changeColumnPrefs(currentUser.getUser().getId(), getOutVoClass(), mappingToChange);
    }

    Class getOutVoClass();

    PreferencesManager getPreferencesManager();
}
