package ru.crp.lvms.web.dto.pagination;

import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;

public class Pagination {
    private int page; //1 based
    private int size;

    // for deserialization
    public Pagination() {
    }

    public Pagination(int page, int size) {
        this.page = page;
        this.size = size;
    }

    public int getPage() {
        return page;
    }

    public void setPage(int page) {
        this.page = page;
    }

    public int getSize() {
        return size;
    }

    public void setSize(int size) {
        this.size = size;
    }

    @Nonnull
    public Pageable toSpringPageable() {
        return new PageRequest(this.page - 1, this.size);
    }

    @Nonnull
    public Pageable toSpringPageable(@Nullable Sort sort) {
        if (sort == null) {
            return toSpringPageable();
        }
        return new PageRequest(this.page - 1, this.size, sort);
    }
}
