package ru.crp.lvms.web.dto.pagination;

import org.springframework.data.domain.Sort;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import java.util.List;
import java.util.stream.Collectors;

import static java.util.Collections.emptyList;

public class SortingOrder {
    private Sort.Direction direction;
    private String field;

    // for deserialization
    public SortingOrder() {
    }

    public SortingOrder(Sort.Direction direction, String field) {
        this.direction = direction;
        this.field = field;
    }

    @Nonnull
    public static List<Sort.Order> toSpringSortabble(@Nullable List<SortingOrder> sort) {
        if (sort == null) {
            return emptyList();
        }
        return sort.stream()
                .map(sortingOrder -> new Sort.Order(sortingOrder.getDirection(), sortingOrder.getField()))
                .collect(Collectors.toList());
    }

    public Sort.Direction getDirection() {
        return direction;
    }

    public void setDirection(Sort.Direction direction) {
        this.direction = direction;
    }

    public String getField() {
        return field;
    }

    public void setField(String field) {
        this.field = field;
    }


    @Override
    public boolean equals(Object o) {
        if (o instanceof SortingOrder) {
            SortingOrder so = (SortingOrder) o;
            if (so.getField() != null && this.field != null) {
                return this.field.equals(so.field) && this.direction == so.getDirection();
            }
        }
        return false;
    }

    @Override
    public int hashCode() {
        return (this.field + this.direction.name()).hashCode();
    }
}
