ALTER TABLE optistruct_tech_constraints ADD COLUMN placeholder VARCHAR(255);

UPDATE optistruct_tech_constraints SET placeholder = 'MINDIM' WHERE id = 1;
UPDATE optistruct_tech_constraints SET placeholder = 'MAXDIM' WHERE id = 2;
UPDATE optistruct_tech_constraints SET placeholder = 'MINGAP' WHERE id = 3;

INSERT INTO optistruct_tech_constraints (id, name, placeholder) VALUES
  (4, 'Глобальное максимальное ограничение на напряжения', 'TENSION');

DROP VIEW optistruct_optimization_tech_constraints_join;
CREATE VIEW optistruct_optimization_tech_constraints_join AS (
  SELECT base.*,
    optistruct_tech_constraints.name AS tech_constraint_name,
    optistruct_tech_constraints.placeholder AS tech_constraint_placeholder

  FROM optistruct_optimization_tech_constraints base
    LEFT JOIN optistruct_tech_constraints ON base.tech_constr_id = optistruct_tech_constraints.id
);

CREATE RULE optistruct_optimization_tech_constraints_join_CREATE
AS ON INSERT TO optistruct_optimization_tech_constraints_join DO INSTEAD (
  INSERT INTO optistruct_optimization_tech_constraints (optimization_id, tech_constr_id, value, name)
  VALUES (NEW.optimization_id, NEW.tech_constr_id, NEW.value, NEW.name)
  RETURNING
    optistruct_optimization_tech_constraints.*,
    NULL :: VARCHAR(255) AS tech_constraint_name,
    NULL :: VARCHAR(255) AS tech_constraint_placeholder
);

CREATE RULE optistruct_optimization_tech_constraints_join_UPDATE
AS ON UPDATE TO optistruct_optimization_tech_constraints_join DO INSTEAD (
  UPDATE optistruct_optimization_tech_constraints
  SET tech_constr_id = NEW.tech_constr_id, value = NEW.value, name = NEW.name
  WHERE id = NEW.id);

CREATE RULE optistruct_optimization_tech_constraints_join_DELETE
AS ON DELETE TO optistruct_optimization_tech_constraints_join DO INSTEAD (
  DELETE FROM optistruct_optimization_tech_constraints WHERE id = OLD.id
);
