ALTER TABLE optimization_base_setting_types ADD COLUMN min_value INTEGER NOT NULL DEFAULT 1;

UPDATE optimization_base_setting_types SET max_value = 100 WHERE id = 2; -- num CAO params
UPDATE optimization_base_setting_types SET max_value = 100 WHERE id = 5; -- num CAD params


DROP VIEW optimization_base_settings_join;
CREATE VIEW optimization_base_settings_join AS (
  SELECT
    obs.*,
    obst.max_value    AS max_value,
    obst.min_value    AS min_value,
    obst.display_name AS name

  FROM optimization_base_settings obs
    JOIN optimization_base_setting_types obst ON obs.type_id = obst.id
);

CREATE RULE optimization_base_settings_join_CREATE AS ON INSERT TO optimization_base_settings_join DO INSTEAD (
  INSERT INTO optimization_base_settings (type_id, optimization_id, current_value)
  VALUES (NEW.type_id, NEW.optimization_id, NEW.current_value)
  RETURNING
    optimization_base_settings.*,
    NULL :: INTEGER AS max_value,
    NULL :: INTEGER AS min_value,
    NULL :: VARCHAR(255) AS name
);

CREATE RULE optimization_base_settings_join_UPDATE AS ON UPDATE TO optimization_base_settings_join DO INSTEAD (
  UPDATE optimization_base_settings
  SET current_value = NEW.current_value
  WHERE id = NEW.id);

CREATE RULE optimization_base_settings_join_DELETE AS ON DELETE TO optimization_base_settings_join DO INSTEAD (
  DELETE FROM optimization_base_settings
  WHERE id = OLD.id
);
