DROP VIEW virtual_simulations_join;

CREATE VIEW virtual_simulations_join AS (
  SELECT
    vs.*,
    cm.name AS composite_material_name,
    f.name  AS sample_file_name,
    s.name  AS standard_name,
    u.name AS owner,
    f2.name AS experiment_results_file_name,
    ec.name as ec_name
  FROM virtual_simulations vs
    INNER JOIN composite_materials cm ON vs.composite_material_id = cm.id
    INNER JOIN users u ON u.id = vs.owner_id
    INNER JOIN effective_characteristics ec ON ec.id = vs.ec_id

    LEFT JOIN files f ON vs.sample_file_id = f.id
    LEFT JOIN standards s ON vs.standard_id = s.id
    LEFT JOIN files f2 ON vs.experiment_results_file_id = f2.id
);