UPDATE nodes SET url = url || '/' WHERE url IS NOT NULL AND url NOT LIKE '%/';

CREATE OR REPLACE FUNCTION normalize_node_url()
  RETURNS TRIGGER AS $body$
BEGIN
  IF (NEW.url IS NOT NULL AND NEW.url NOT LIKE '%/') THEN
    NEW.url = NEW.url || '/';
  END IF;
  RETURN NEW;
END;
$body$ LANGUAGE plpgsql;

CREATE TRIGGER node_url_normalization_INSERT
  BEFORE INSERT ON nodes
    FOR EACH ROW EXECUTE PROCEDURE normalize_node_url();

CREATE TRIGGER node_url_normalization_UPDATE
  BEFORE UPDATE ON nodes
    FOR EACH ROW EXECUTE PROCEDURE normalize_node_url();
