CREATE TABLE optimization_solvers (
  id SERIAL,
  name VARCHAR(255) UNIQUE,
  display_name VARCHAR(255) UNIQUE,

  PRIMARY KEY(id)
);

INSERT INTO optimization_solvers(name,display_name) VALUES
 ('Toska', 'Toska'),
 ('ModFrontier', 'ModFrontier'),
 ('Optistruct', 'Optistruct');

ALTER TABLE optimizations ADD COLUMN solver_id INTEGER NOT NULL REFERENCES optimization_solvers;

DROP VIEW optimizations_join;

CREATE VIEW optimizations_join AS
  SELECT
    o.*,
    os.display_name AS solver_name,
    u.name                                                                                     AS owner,
    ss.uname                                                                                   AS solving_status,
    ps.uname                                                                                   AS postprocessing_status,
    ot.name                                                                                    AS optimization_type,
    opf.path_names || '/' :: VARCHAR || o.name :: VARCHAR                                      AS path_names,
    opf.path || concat('{', '"name":"', o.name, '", "id":', o.id, ', "type":null}') :: VARCHAR AS path,
    o2.name                                                                                    AS reference,
    fi.name                                                                                    AS image_name
  FROM optimizations o
    JOIN optimization_solvers os ON os.id = o.solver_id
    JOIN users u ON u.id = o.owner_id
    JOIN solving_statuses ss ON ss.id = o.solving_status_id
    JOIN postprocessing_statuses ps ON ps.id = o.postprocessing_status_id
    JOIN optimization_types ot ON ot.id = o.optimization_type_id
    JOIN optimization_folders opf ON opf.id = o.pid
    LEFT JOIN optimizations o2 ON o2.id = o.reference_id
    LEFT JOIN files fi ON fi.id = o.image_file_id;
