CREATE OR REPLACE VIEW construction_elements_tree AS
  SELECT
    id,
    pid,
    name,
    path,
    path_names,
    'Folder' :: tree_node_type AS item_type
  FROM folders
  WHERE tree_type = 'constructionElements'
  UNION
  SELECT
    id,
    pid,
    name,
    path,
    path_names,
    'ConstructionElement' :: tree_node_type AS item_type
  FROM construction_elements
  UNION
  SELECT
    id,
    pid,
    name,
    path,
    path_names,
    'ConstructionElementFolder' :: tree_node_type AS item_type
  FROM construction_element_file_types
  UNION
  SELECT
    id,
    pid,
    name,
    path,
    path_names,
    'File' :: tree_node_type AS item_type
  FROM files
  WHERE file_type_id IN (8,9,10) AND pid IS NOT NULL;

CREATE OR REPLACE VIEW construction_elements_tree_join AS
  SELECT
    cet.*,
    (SELECT string_agg(DISTINCT item_type :: TEXT, ',')
     FROM construction_elements_tree cet2
     WHERE cet2.pid = cet.id) AS children_types
  FROM construction_elements_tree cet;


-- CREATE OR REPLACE RULE construction_elements_tree_update_elements AS ON UPDATE TO construction_elements_tree_join DO INSTEAD (
--   UPDATE construction_elements
--   SET NAME = NEW.name
--   WHERE id = NEW.id);
--
-- CREATE OR REPLACE RULE construction_elements_tree_update_folders AS ON UPDATE TO construction_elements_tree_join DO INSTEAD (
--   UPDATE folders
--   SET NAME = NEW.name
--   WHERE id = NEW.id);
--
-- CREATE OR REPLACE RULE construction_elements_tree_update_files AS ON UPDATE TO construction_elements_tree_join DO INSTEAD (
--   UPDATE files
--   SET NAME = NEW.name
--   WHERE id = NEW.id);
