CREATE FUNCTION add_slash_to_end_of_url()
  RETURNS TRIGGER AS $body$
BEGIN

  NEW.url := NEW.url || '/';

  RETURN NEW;
END;
$body$ LANGUAGE plpgsql;

CREATE TRIGGER node_slash_trigger
BEFORE INSERT OR UPDATE ON nodes
FOR EACH ROW
WHEN (SUBSTRING(NEW.url FROM '.$') != '/')
EXECUTE PROCEDURE add_slash_to_end_of_url();

UPDATE nodes SET url = url || '/' WHERE (SUBSTRING(url FROM '.$') != '/');
