CREATE VIEW nodes_for_cluster_info_view AS (
  SELECT
    n.id,
    n.cluster_id,
    c.name,
    c.type_id,
    n.alive                                                           AS is_alive,
    n.enabled                                                         AS is_enabled,
    n.num_cores,
    n.memory,
    CASE WHEN c.type_id = 1
      THEN
        (SELECT EXISTS(
            SELECT id
            FROM tasks
            WHERE node_id = n.id
                  AND status_id IN (3, 4, 5, 6, 7, 8)))
    ELSE
      -- for slurm tasks we can use multiple nodes and they are stored in the separate table
      (SELECT EXISTS(
          SELECT t.id
          FROM tasks t
            JOIN slurm_tasks_info sti ON sti.task_id = t.id
          WHERE t.status_id IN (3, 4, 5, 6, 7, 8)
                AND sti.nodes @> ARRAY [n.name]
      ))
    END                                                               AS is_busy,
    (SELECT ARRAY(SELECT solver_name
                  FROM nodes_solver_types
                  WHERE node_id = n.id)) AS enabled_solvers
  FROM nodes n
    JOIN clusters c ON n.cluster_id = c.id
);
