/**
 * Application Controller
 *
 */

(function () {
  "use strict";

  window.App.Controllers = {};
  window.App.Controllers.AppController = Backbone.Marionette.Controller.extend({

    initialize: function () {
      this.mainWrapperView = window.App.MainWrapperView = window.App.MainWrapperView || new window.App.Views.AppMainWrapperView();
      window.App.mainAppContentRegion.show(this.mainWrapperView);

      this.showApp();
    },

    showSidebar: function () {
      window.App.execute("sidebar:show", {region: this.mainWrapperView.sidebarWrapperRegion});
    },

    showAdminPage: function(){
      window.App.execute("admin:show", {defaultPage: "nodes", region: this.mainWrapperView.contentWrapperRegion});
    },

    logout: function() {
      window.location.assign("logout");
    },

    showApp: function () {
      var that = this;
      that.showSidebar();
      that.showProject();
    },

    showProject: function () {
      App.ProjectModule.start({region: this.mainWrapperView.contentWrapperRegion})
    },

    showInitialPage: function() {
     var initialPage = localStorage.getItem('redirect_auth_hash') || "project/home";
     localStorage.removeItem('redirect_auth_hash');
     App.navigate(initialPage, {trigger: true});
//         App.navigate("project/home", {trigger: true});
    },

    showProfilePage: function (id, mode) {
      var options = { page: "ProjectUserPage", id: parseInt(id), mode: mode };
      window.App.ProjectModule.showProjectPage(options);
    }

  });

})();
