(function () {
  "use strict";



  window.App.Helpers.ObjectValidator = function (object, config) {
    this.validators = {
      createHasValueValidator: function (message) {
        return function (object, fieldName) {
          const valueToValidate = object[fieldName];
          let response = {};
          if (_.isNull(valueToValidate) && _.isUndefined(valueToValidate) && _.isEmpty(valueToValidate)) {
            response = {
              value: valueToValidate,
              isValid: true,
              errorMessage: null
            }
          } else {
            response = {
              value: valueToValidate,
              isValid: false,
              errorMessage: message
            }
          }
          return response;
        }
      }
    };



    _.map(config, (value, key) => {
      var validator = this.validators[value[0].validator](value[0].message);
      return validator(object, key);
    });


  };

})();
