(function () {

  window.App.Models.BaseModel = Backbone.Model.extend({

    name: null,

    initialize: function (options) {
      this.options = options || {};
      _.bindAll(this, "updateModel");
      window.App.vent.on('apply:changes', this.updateModel);
    },

    updateModel: function () {
      this.trigger("update:path");
    },

    validate: function (attrs, options) {
      var error = {};
      _.each(options.fields, function (v, k) {
        if (!v.length) {
          error[k] = "Must have"
        }
      }, this);

      if (!_.isEmpty(error)) {
        return error;
      }
    },

    getName: function () {
      if (!this.name) {
        throw new Error("No model name for : " + this.urlRoot);
      }
      return this.name;
    }
  });
})();
