(function () {
  "use strict";

  window.App.Views.FileMainView = Marionette.LayoutView.extend({
    template: "./views/templates/project/files/file_main.html.ejs",
    className: "ui-file-main row",

    ui: {
      name:         ".js-name",
      manufacture:  ".js-manufacture",
      description:  ".js-description",
      path:         ".js-path"
    },

    events: {
      "keyup @ui.name":         "onChange",
      "keyup @ui.manufacture":  "onChange",
      "keyup @ui.description":  "onChange",
      "click @ui.path":         "onClickPathLnk"
    },

    initialize: function (options) {
      this.options = options || {};
    },

    onChange: function (e) {
      var $target = $(e.target);
      var key = $target.attr("id");
      var value = this.ui[key].val();
      if (key == "name") {
        if (value.length == 0) {
          this.ui.name.closest(".form-group").addClass("has-error");
          window.alertify.error("Название не может быть пустым.");
          return;
        } else {
          this.ui.name.closest(".form-group").removeClass("has-error");
        }
      }
      this.model.set(key, value);
    },

    templateHelpers: function() {
      return {
        isView: this.options.mode == "view"
      }
    }

  });

}());