(function() {
  "use strict";
  window.App.Views.FileParametersPage = window.App.Views.BasePage.extend({
    template: "./views/templates/project/files/files_page.html.ejs",

    initialize: function () {
      window.App.Views.BasePage.prototype.initialize.apply(this, arguments);
      this.page = "parameters";
    },

    onEditClick: function () {
      window.App.navigate("#project/" + this.options.modelName + "/" + this.model.id + "/edit", { trigger: true });
    },

    onCancelClick: function () {
      window.App.navigate("#project/" + this.options.modelName + "/" + this.model.id + "/view", { trigger: true });
    },

    onSaveClick: function () {
      var that = this;
      this.model.save({}, {
        success: function () {
          window.App.navigate("#project/" + that.options.modelName + "/" + that.model.id + "/view", { trigger: true });
        },
        error: function (xhr) {
          console.error("Failed to save: ", xhr);
        }
      });
    },

    onRender: function () {
      this.initAndShowMainView(this.getRegion("mainRegion"));
      window.App.Views.MaterialBasePage.prototype.onRender.call(this);
    },

    initAndShowMainView: function (region) {
      this.mainView = new window.App.Views.FileMainView({
        layoutView: this,
        mode: this.mode,
        model: this.model
      });
      region.show(this.mainView);
    }

  });

})();

