(function() {
  "use strict";
  window.App.Views.MaterialFilesPage = window.App.Views.MaterialBasePage.extend({
    template: "./views/templates/project/material/material_base_page.html.ejs",

    initialize: function () {
      window.App.Views.MaterialFilesPage.__super__.initialize.apply(this, arguments);
      this.controls = ["new"];
      this.page = "files";
    },

    onShow: function () {
      this.initAndDrawTables();
    },

    initAndDrawTables: function () {
      this.filesView = new window.App.Views.FilesListView(_.extend({
        gridCollection: new window.App.Collections.Files([], {
          objectId: this.model.id,
          objectType: "materials",
          fileType: "materialFiles",
          pageable: true,
          filters: this.options.filters || null
        }),
        actions: ["open", "new", "delete", "export"],
        isFile: true,
        title: "Файлы Материала"
      }, {}));
      this.getRegion("mainRegion").show(this.filesView);
    }

  });

})();