(function () {
  "use strict";

  window.App.Views.MaterialMainView = Marionette.LayoutView.extend({
    template: "./views/templates/project/material/material_main.html.ejs",
    className: "ui-material-main row",

    ui: {
      name:         ".js-name",
      manufacture:  ".js-manufacture",
      source:       ".js-source",
      description:  ".js-description",
      path:         ".js-path"
    },

    events: {
      "keyup @ui.name":         "onChange",
      "keyup @ui.manufacture":  "onChange",
      "keyup @ui.source":       "onChange",
      "keyup @ui.description":  "onChange",
      "click @ui.path":         "onClickPathLnk"
    },

    onClickPathLnk: function () {
      if (this.ui.path.hasClass("disabled")) return false;
      this.changePathModalView = new window.App.Views.ChangePathModal({ treeType: "materials", onlyFolders: true });
      this.changePathModal = new Backbone.BootstrapModal({
        content: this.changePathModalView,
        title: "Выбрать путь",
        animate: true,
        cancelText: "Отменить",
        okText: "Сохранить"
      }).open();
      this.listenTo(this.changePathModalView, "path:select:done", this.pathSelectDone);
    },

    pathSelectDone: function (treeNode) {
      this.ui.path.text(window.App.Helpers.ShowPath(treeNode.path));
      this.model.set({ pid: treeNode.id });
    },

    initialize: function (options) {
      this.options = options || {};
    },

    onChange: function (e) {
      var $target = $(e.target);
      var key = $target.attr("id");
      var value = this.ui[key].val();
      if (key == "name") {
        if (value.length == 0) {
          this.ui.name.closest(".form-group").addClass("has-error");
          window.alertify.error("Название не может быть пустым.");
          return;
        } else {
          this.ui.name.closest(".form-group").removeClass("has-error");
        }
      }
      this.model.set(key, value);
    },

    templateHelpers: function() {
      return {
        isView: this.options.mode == "view"
      }
    }

  });

}());