(function() {
  "use strict";
  window.App.Views.MaterialParametersPage = window.App.Views.MaterialBasePage.extend({
    template: "./views/templates/project/material/material_parameters_page.html.ejs",

    initialize: function () {
      window.App.Views.MaterialParametersPage.__super__.initialize.apply(this, arguments);
      this.page = "parameters";
    },

    onRender: function () {
      this.initAndShowMainView(this.getRegion("mainRegion"));
      this.initAndShowPlotView(this.getRegion("plotRegion"));
      window.App.Views.MaterialBasePage.prototype.onRender.call(this);
    },

    initAndShowMainView: function (region) {
      this.mainView = new window.App.Views.MaterialMainView({ layoutView: this, mode: this.mode, model: this.model });
      region.show(this.mainView);
    },

    initAndShowPlotView: function (region) {
      var that = this;
      this.plotParameters = new window.App.Collections.PlotParameters({
        materialId: this.model.get("id"),
        materialType: "materials"
      });
      this.plotParameters.fetch({
        success: function () {
          that.plotView = new window.App.Views.MaterialPlotView({
            layoutView: that,
            mode: that.mode,
            collection: that.plotParameters,
            materialId: that.model.id
          });
          region.show(that.plotView);
        }
      });
    }

  });

})();

