(function () {
  "use strict";

  window.App.Views.AddToscaTechnologicalConstrainParameterView = Marionette.LayoutView.extend({
    template: "./views/templates/project/optimization/add_tosca_technological_constraint_parameter.html.ejs",
    ui: {
      tree: ".js-tree-region"
    },

    initialize: function (options) {
      this.options = options || {};
      this.nodes = null;
      this.selectedNode = null;
      this.listenTo(this, "ok", this.onSubmit);
      this.listenTo(this, "cancel", this.onCancel);
    },

    onRender: function () {
      this.renderTree();
    },

    renderTree: function () {

    },

    onNodeClick: function (event, treeId, treeNode) {
      console.log(treeNode )
    },

    passModal: function (md) {
      this.md = md;
    },

    onCancel: function () {
      window.App.navigate("#project/optimizations/" + this.model.get("optimizationId") + "/settings/edit/4", {trigger: true});
    },

    onSubmit: function (md) {
      md.preventClose();
      if (_.isNull(this.selectedNode)) {
        window.alertify.error("Нужно выбрать конкретный параметр.")
      } else {
        this.trigger("parameter:selected", this.selectedNode);
        md.close();
      }
    },

    templateHelpers: function () {
      return {}
    }

  });

}());