window.OptimizationMainData = React.createClass({
  getInitialState: function () {
    return this.props.optimization.toJSON();
  },

  onChange: function (e) {
    const state = {};
    this.currentParameter = e.target.id;
    state[e.target.id] = e.target.value;
    this.setState(state);
    if (e.target.value != "") {
      this.props.optimization.set(state);
    }
  },

  onBlur: function () {
    if (this.state[this.currentParameter] == "") {
      window.alertify.error("Can't be empty");
      return false;
    }
    this.props.optimization.save(null, {async: false});
  },


  render: function () {
    var opts = {
      onChange: this.onChange,
      onBlur: this.onBlur
    };
    return (
      <div className="ui-optimization-main-form">
        <div className="row form-group">
          <window.TextInputField id="name" label="Название" placeholder="Название оптимизации" value={this.state.name || ""} disabled={this.props.isView} size={{label: 3, field: 9}} {...opts} />
        </div>
        <div className="row form-group">
          <window.ReferenceInputField label="Базовый объект" placeholder="Базовый объект" optimization={this.props.optimization} referenceType={"optimization"} referenceId={this.state.referenceId} reference={this.state.reference} disabled={this.props.isView} {...opts} />
        </div>
        <div className="row form-group">
          <window.PathInputField label="Путь" placeholder="Путь" path={this.state.pathNames} optimization={this.props.optimization} disabled={this.props.isView} {...opts} />
        </div>
        <div className="row form-group">
          <window.TextInputField id="optimizationType" label="Тип" placeholder="Тип оптимизации" value={this.state.optimizationType || ""} disabled={true} size={{label: 3, field: 4}} />
          <window.TextInputField id="solverName" label="CAE/CAO" placeholder="Расчетный пакет" value={(this.state.caeName+"/"+this.state.caoName) || ""} disabled={true} size={{label: 2, field: 3}} />
        </div>
        <div className="row form-group">
          <window.TextInputField id="solvingStatus" label="Статус" placeholder="Статус" value={this.state.solvingStatus || ""} disabled={true} size={{label: 3, field: 4}} />
          <window.TextInputField id="owner" label="Автор" placeholder="Автор" value={this.state.owner || ""} disabled={true} size={{label: 2, field: 3}} />
        </div>
        <div className="row form-group">
          <window.TextInputField id="creationDate" label="Создано" placeholder="Создано" value={moment(this.state.creationDate).format("hh:mm DD.MM.YY")} disabled={true} size={{label: 3, field: 4}} />
          <window.TextInputField id="modificationDate" label="Изменено" placeholder="Изменено" value={moment(this.state.modificationDate).format("hh:mm DD.MM.YY")} disabled={true} size={{label: 2, field: 3}} />
        </div>
      </div>
    )
  }
});