window.OptimizationModeFrontierBorder = React.createClass({
  getInitialState: function () {
    return this.validateState(this.props.data, false);
  },

  onChange: function (e) {
    var state = this.state;
    state[e.target.id] = _.isEmpty(e.target.value) ? null : e.target.value.replace(",", ".");
    this.setState(this.validateState(state, true));
  },

  onBlur: function () {
    $.ajax({
      type: "PUT",
      url: "rest/optimizations/" + this.state.optimizationId + "/ModeFrontier/" + this.props.borderType + "/" + this.state.id,
      contentType: "application/json",
      data: JSON.stringify({
        id: this.state.id,
        lowerBound: this.state.lowerBound,
        upperBound: this.state.upperBound,
        optimizationId: this.state.optimizationId,
        sampling: this.state.sampling,
        name: this.state.name
      }),
      success: () => this.forceUpdate()
    });
  },
  validateState: function (state, showMessages) {
    state.hasAllValues = !_.isNull(state.lowerBound) && !_.isNull(state.upperBound) && !_.isNull(state.sampling);
    state.samplingValid = !_.isNull(state.sampling) && (state.sampling >= 0) && (state.sampling != 1);
    state.bordersValid = !_.isNull(state.lowerBound) && !_.isNull(state.upperBound) && (parseFloat(state.lowerBound) < parseFloat(state.upperBound));
    state.isValid = state.hasAllValues && state.samplingValid && state.bordersValid;
    if (state.sampling == 0) state.sampling = "0";
    if (showMessages) this.showValidationErrorMessages(state);
    if (state.isValid) {
      state.step = state.sampling == "0" ? "Непрерывно" : (state.upperBound - state.lowerBound) / (state.sampling - 1);
    } else {
      state.step = null;
    }
    return state;
  },

  showValidationErrorMessages: function (state) {
    if (!state.isValid) {
      if (state.sampling && !state.samplingValid) {
        clearInterval(this.samplingErrorMessageTimer);
        this.samplingErrorMessageTimer = setTimeout(() => {
          window.alertify.error("Дискретизация задана некорректно. Правило: D >= 0, D <> 1");
        }, 700);
      }
      if (state.lowerBound && state.upperBound && !state.bordersValid) {
        clearInterval(this.bordersErrorMessageTimer);
        this.bordersErrorMessageTimer = setTimeout(() => {
          window.alertify.error("Нижняя и верхняя граница, дискретизация должны быть заданы. Нижняя граница должна быть меньше верхней.");
        }, 700);
      }
    } else {
      clearInterval(this.samplingErrorMessageTimer);
      clearInterval(this.bordersErrorMessageTimer);
    }
  },

  render: function () {
    const btnClass = this.state.isValid ? "success" : "danger";
    const formClass = this.state.isValid ? "success" : "error";
    return (
      <div className="row" style={{"marginBottom": "7px"}}>
        <div className="col-md-1">
          <button type="button" className={"btn btn-" + btnClass} disabled>{this.state.name}</button>
        </div>
        <div className="col-md-2">
          <div className={"form-group has-" + formClass}>
            <input id="lowerBound" disabled={this.props.isView} type="text" className="form-control"
                   placeholder="Не задано" onBlur={this.onBlur} onChange={this.onChange}
                   value={this.state.lowerBound || ""}/>
          </div>
        </div>
        <div className="col-md-2">
          <div className={"form-group has-" + formClass}>
            <input id="upperBound" disabled={this.props.isView} type="text" className="form-control"
                   placeholder="Не задано" onBlur={this.onBlur} onChange={this.onChange}
                   value={this.state.upperBound || ""}/>
          </div>
        </div>
        <div className="col-md-2">
          <div className={"form-group has-" + formClass}>
            <input id="sampling" disabled={this.props.isView} type="text" className="form-control"
                   placeholder="D >= 0, D <> 1" onBlur={this.onBlur} onChange={this.onChange}
                   value={this.state.sampling || ""}/>
          </div>
        </div>
        <div className="col-md-2">
          <div className="form-group">
            <input id="sampling" disabled type="text" className="form-control" placeholder="Не задано"
                   value={this.state.step || ""}/>
          </div>
        </div>
      </div>
    )
  }
});