var OptimizationOptistructConstraints = Backbone.Collection.extend({
  url: function () {
    return "rest/optimizations/" + this.options.optimizationId + "/Optistruct/constraints";
  },

  initialize: function (models, options) {
    this.options = options || {};
  }
});

var OptistructConstraintTypes = Backbone.Collection.extend({
  url: function () {
    return "rest/optimizations/Optistruct/constraints";
  }
});

let OptimizationOptistructLoadings = Backbone.Collection.extend({
  url: function () {
    return "rest/optimizations/" + this.options.optimizationId + "/Optistruct/loadSteps";
  },

  initialize: function (models, options) {
    this.options = options || {};
  }
});

window.OptimizationOptistructConstraints = React.createClass({
  getInitialState: function () {
    return {
      constraints: new OptimizationOptistructConstraints(null, {optimizationId: this.props.optimizationId}),
      constraintTypes: new OptistructConstraintTypes(),
      loadings: new OptimizationOptistructLoadings(null, { optimizationId: this.props.optimizationId }),
      lnsets: []
    };
  },

  componentDidMount: function () {
    this.totalUpdate();
    window.App.commands.setHandler("basic:NUM_CONSTRAINTS:changed", () => {
      this.fetchData().then(() => this.forceUpdate(), null);
    });
  },

  totalUpdate: function () {
    this.fetchData().then(() =>
      this.fetchConstraintTypes().then(() =>
        this.fetchLoadings().then(() =>
          this.fetchSets().then((lnsets) =>
            this.setState({ lnsets: lnsets }), null),
          null),
        null),
    null);
  },

  fetchData: function () {
    return new Promise((resolve, reject) => {
      this.state.constraints.fetch({
        success: resolve,
        error: reject
      });
    })
  },

  fetchSets: function () {
    return $.get("rest/optimizations/" + this.props.optimizationId + "/Optistruct/lnsets/selected");
  },

  fetchConstraintTypes: function () {
    return new Promise((resolve, reject) => {
      this.state.constraintTypes.fetch({
        success: resolve,
        error: reject
      });
    })
  },

  fetchLoadings: function () {
    return new Promise((resolve, reject) => {
      this.state.loadings.fetch({
        success: resolve,
        error: reject
      });
    })
  },

  onMinimizeClick: function (e) {
    $(e.target).closest(".ui-collapsable-block").toggleClass("minimized");
    $(e.target).closest(".ui-minimize").find("span").toggle();
  },

  mapConstraints: function () {
    return this.state.constraints.toJSON().map((constraint) => {
      return <window.OptimizationOptistructConstraint isView={this.props.isView} onChange={this.props.onChange} key={constraint.id} lnsets={this.state.lnsets} loadings={this.state.loadings} data={constraint} types={this.state.constraintTypes} />
    });
  },

  render: function () {
    return (
      <div className="ui-optimization-block ui-collapsable-block ui-optimization-settings-container">
        <div className="ui-optimization-block-header clearfix">
          <span className="pull-left">Ограничения</span>
        </div>
        <div className="ui-optimization-block-body">
          <div className="clearfix" style={{"marginBottom": "7px"}}>
            <div className="col-md-3">Параметр</div>
            <div className="col-md-2">Аттрибуты</div>
            <div className="col-md-2">Нагружения</div>
            <div className="col-md-3">Объект приложения</div>
            <div className="col-md-2">Границы (ниж./верх.)</div>
          </div>
          {this.mapConstraints()}
        </div>
      </div>
    )
  }
});