let OptimizationOptistructFunctions = Backbone.Collection.extend({
  url: function () {
    return "rest/optimizations/" + this.options.optimizationId + "/Optistruct/targetFunctions";
  },

  initialize: function (models, options) {
    this.options = options || {};
  }
});

let OptimizationOptistructFunctionsOptimizationTypes = Backbone.Collection.extend({
  url: function () {
    return "rest/optimizations/Optistruct/targetFunctions/types";
  }
});

let OptimizationOptistructFunctionTypes = Backbone.Collection.extend({
  url: function () {
    return "rest/optimizations/Optistruct/targetFunctions";
  }
});

let OptimizationOptistructLoadings = Backbone.Collection.extend({
  url: function () {
    return "rest/optimizations/" + this.options.optimizationId + "/Optistruct/loadSteps";
  },

  initialize: function (models, options) {
    this.options = options || {};
  }
});

window.OptimizationOptistructFunctions = React.createClass({
  getInitialState: function () {
    return {
      functions: new OptimizationOptistructFunctions(null, { optimizationId: this.props.optimizationId }),
      loadings: new OptimizationOptistructLoadings(null, { optimizationId: this.props.optimizationId }),
      optimizationTypes: new OptimizationOptistructFunctionsOptimizationTypes(),
      functionTypes: new OptimizationOptistructFunctionTypes(),
      lnsets: []
    };
  },
  componentDidMount: function () {
    this.totalUpdate();
    window.App.commands.setHandler("basic:NUM_TARGET_FUNCS:changed", () => {
      this.fetchData().then(() => this.forceUpdate(), null);
    });
  },

  totalUpdate: function () {
    this.fetchData().then(() =>
      this.fetchOptimizationTypes().then(() =>
        this.fetchFunctionTypes().then(() =>
          this.fetchLoadings().then(() =>
            this.fetchSets().then((lnsets) =>
              this.setState({ lnsets: lnsets }), null),
            null),
          null),
        null),
    null);
  },

  fetchLoadings: function () {
    return new Promise((resolve, reject) => {
      this.state.loadings.fetch({
        success: resolve,
        error: reject
      });
    })
  },

  fetchData: function () {
    return new Promise((resolve, reject) => {
      this.state.functions.fetch({
        success: resolve,
        error: reject
      });
    })
  },

  fetchOptimizationTypes: function () {
    return new Promise((resolve, reject) => {
      this.state.optimizationTypes.fetch({
        success: resolve,
        error: reject
      });
    })
  },

  fetchFunctionTypes: function () {
    return new Promise((resolve, reject) => {
      this.state.functionTypes.fetch({
        success: resolve,
        error: reject
      });
    })
  },

  fetchSets: function () {
    return $.get("rest/optimizations/" + this.props.optimizationId + "/Optistruct/lnsets/selected");
  },

  onMinimizeClick: function (e) {
    $(e.target).closest(".ui-collapsable-block").toggleClass("minimized");
    $(e.target).closest(".ui-minimize").find("span").toggle();
  },

  mapFunctions: function () {
    return this.state.functions.toJSON().map((func) => {
      return <window.OptimizationOptistructFunction isView={this.props.isView} onChange={this.props.onChange} key={func.id} data={func} functionTypes={this.state.functionTypes} lnsets={this.state.lnsets} loadings={this.state.loadings} optimizationTypes={this.state.optimizationTypes} />
    });
  },

  render: function () {
    return (
      <div className="ui-optimization-block ui-collapsable-block ui-optimization-settings-container">
        <div className="ui-optimization-block-header clearfix">
          <span className="pull-left">Определение целевых функций</span>
        </div>
        <div className="ui-optimization-block-body">
          <div className="clearfix" style={{"marginBottom": "7px"}}>
            <div className="col-md-3">Параметр</div>
            <div className="col-md-2">Нагружения</div>
            <div className="col-md-2">Аттрибуты</div>
            <div className="col-md-3">Объект приложения</div>
            <div className="col-md-2">Тип</div>
          </div>
          {this.mapFunctions()}
        </div>
      </div>
    )
  }
});