window.OptimizationOptistructLoading = React.createClass({
  getInitialState: function () {
    return this.props.data
  },

  componentDidMount: function () {
    this.initializeMultiSelect();
  },

  initializeMultiSelect: function () {
    var that = this;
    var data = this.prepareParsedLoadingsToSelect2(this.props.parsedLoadings);
    $('.js-multiselect-' + this.state.id).select2({
      data: data,
      placeholder: _.isEmpty(this.props.parsedLoadings) ? "Нет доступных нагрузок" : "Ничего не выбрано"
    }).on("change", function () {
      var values = $(this).val();
      that.onMultiSelectChange(values);
    })
  },

  prepareParsedLoadingsToSelect2: function (parsedLoadings) {
    return _.map(parsedLoadings, (parsedLoading) => {
      return {
        id: parsedLoading.id,
        text: parsedLoading.name,
        selected: _.indexOf(this.state.selectedLoadIds, parsedLoading.id) !== -1
      }
    });
  },

  onMultiSelectChange: function (values) {
    var currentState = this.state;
    currentState.selectedLoadIds = values;
    this.saveChanges(currentState);
  },

  onSelectChange: function (e) {
    var currentState = this.state;
    currentState[e.target.id] = e.target.value;
    this.saveChanges(currentState);
  },

  onCheckboxChange: function (e) {
    var currentState = this.state;
    currentState[e.target.id] = e.target.checked;
    this.saveChanges(currentState);
  },

  saveChanges: function (state) {
    $.ajax({
      type: "PUT",
      url: "rest/optimizations/" + this.state.optimizationId + "/Optistruct/loadSteps/" + this.state.id,
      contentType: "application/json",
      data: JSON.stringify(state),
      success: (data) => this.setState(data)
    });
  },

  render: function () {
    var checkboxOptions = {};
    if (this.state.isFixed) {
      checkboxOptions.checked = "checked";
    }
    return (
      <div className="row" style={{"marginBottom": "7px"}}>
        <div className="col-md-4">
          <select disabled={this.props.isView || _.isEmpty(this.props.parsedLoadings)} className={"form-control js-multiselect-" + this.state.id} multiple={true}></select>
        </div>
        <div className="col-md-4">
          <div className="form-group">
            <select disabled={this.props.isView} value={this.state.calculationType} onChange={this.onSelectChange} className="form-control" id="calculationType">
              {this.props.calculationTypes.map((type, index) => <option key={index} value={type}>{type}</option>)}
            </select>
          </div>
        </div>
        <div className="col-md-2">
          <input disabled={this.props.isView || this.state.calculationType === "STATIC"} onChange={this.onCheckboxChange} id="isFixed" type="checkbox" style={{"marginLeft": "7px", "marginTop": "12px"}} checked={this.state.isFixed} />
        </div>
      </div>
    )
  }
});