let OptimizationOptistructLnsets = Backbone.Collection.extend({
  url: function () {
    return "rest/optimizations/" + this.options.optimizationId + "/Optistruct/lnsets/selected";
  },

  initialize: function (models, options) {
    this.options = options || {};
  }
});

window.OptimizationOptistructLnsets = React.createClass({
  getInitialState: function () {
    return {
      lnsets: new OptimizationOptistructLnsets(null, { optimizationId: this.props.optimizationId }),
    };
  },

  componentDidMount: function () {
    this.fetchData();
    this.initSetsSuggest();
  },

  initSetsSuggest: function () {
    this.$setsSelect = $('.ui-suggest-lnsets');
    this.$setsSelect.select2(
      new window.App.Helpers.Select2Config({
        el: ".ui-suggest-lnsets",
        placeholder: "Выберите группу",
        url: "rest/optimizations/" + this.props.optimizationId + "/Optistruct/lnsets/suggest",
        isNumber: false,
        allowClear: true,
        minimumInputLength: 0
      })
    ).on('change', this.onChooseSet);
  },

  onChooseSet: function (e) {
    let id = e.target.value;
    if (id) {
      $.ajax({
        type: "POST",
        url: 'rest/optimizations/' + this.props.optimizationId + "/Optistruct/lnsets/" + e.target.value + "?isSelected=true",
        success: () => this.fetchData()
      });
    }
  },

  fetchData: function () {
    this.state.lnsets.fetch().done(() => {
      this.forceUpdate();
    });
  },

  onMinimizeClick: function (e) {
    $(e.target).closest(".ui-collapsable-block").toggleClass("minimized");
    $(e.target).closest(".ui-minimize").find("span").toggle();
  },

  onRemoveSet: function () {
    this.fetchData()
  },

  toggleActive: function (id, props) {
    window.App.vent.trigger("set:toggle:active", id);
  },
  render: function () {
    let opts = {};
    if (this.props.isView) opts["disabled"] = "disabled";
    return (
        <div className="ui-optimization-block ui-collapsable-block ui-optimization-settings-container">
        <div className="ui-optimization-block-header clearfix">
          <span className="pull-left">Определение наборов узлов</span>
        </div>
        <div className="ui-optimization-block-body">
          <div className="row">
            <div className="col-md-6 ui-suggest-sets-wrap">
              <div className="form-group"><select className="form-control ui-suggest-lnsets" {...opts}></select></div>
            </div>
          </div>
          <div className="row ui-sets-wrap">
              {this.state.lnsets.toJSON().map((parameter, i) => {
                  return <window.OptimizationOptistructLnset toggleActive={this.toggleActive} isView={this.props.isView} onRemoveSet={this.onRemoveSet} key={parameter.id} data={parameter}/>
              })}
          </div>
        </div>
      </div>
    )
  }
});