var OptimizationSettingsBasicParameter = Backbone.Model.extend({
  url: function () {
    return "rest/optimizations/" + this.get("optimizationId") + "/" + this.options.solverType + "/basic/" + this.get("id");
  },
  initialize: function (attrs, options) {
    this.options = options || {};
  }
});

window.OptimizationSettingsBasicParameter = React.createClass({
  getInitialState: function () {
    this.stateModel = new OptimizationSettingsBasicParameter(this.props.data, { solverType: this.props.solverType});
    return this.stateModel.toJSON();
  },

  saveParameter: function (value) {
    if (this.props.isView) return false;

    value = value == "" ? this.state.minValue : parseInt(value);

    if (value < this.state.minValue) {
      value = this.state.minValue;
    }

    if (value > this.state.maxValue) {
      value = this.state.maxValue;
    }
    
    this.stateModel.save({ currentValue: value }).done(() => {
      this.setState(this.stateModel.toJSON());
      window.App.commands.execute("basic:" + this.state.type + ":changed");
    });
  },

  prepareRadios: function () {
    var radios = [];
    var minValue = this.state.minValue === undefined ? 1 : this.state.minValue;
    for (let i= minValue; i<= this.state.maxValue; i++) {
      let className = "ui-optimization-radio pull-left";
      if (i == this.state.currentValue) className += " active";
      if (this.props.isView) className += " disabled";
      let radio = <div className={className} key={i} onClick={this.onRadioClick.bind(this, i)}>{i}</div>;
      radios.push(radio);
    }
    return (
      <div className="col-md-7 clearfix">{radios}</div>
    );
  },

  onRadioClick: function (i) {
    this.saveParameter(i);
  },

  onInputChange: function (e) {
    this.setState({ currentValue: e.target.value });
  },

  onInputBlur: function (e) {
    this.saveParameter(e.target.value);
  },

  prepareInput: function () {
    return(
      <div className="col-md-1">
        <input disabled={this.props.isView} className="form-control ui-basic-parameter-input" type="number" min={this.state.minValue} max={this.state.maxValue} onChange={this.onInputChange} onBlur={this.onInputBlur} value={this.state.currentValue || undefined} />
      </div>);
  },

  render: function() {
    return (
      <div className="ui-optimization-basic-parameter clearfix">
        <div className="col-md-5 ui-optimization-parameter-label">{this.state.name}</div>
        {this.state.maxValue > 15 ? this.prepareInput() : this.prepareRadios()}
      </div>
    )
  }
});
