var OptimizationToscaTechnologicalConstraints = Backbone.Collection.extend({
  url: function () {
    return "rest/optimizations/" + this.options.optimization.id + "/Tosca/technologicalConstraints";
  },

  initialize: function (models, options) {
    this.options = options || {};
  }
});

var OptimizationToscaTechnologicalConstraintSets = Backbone.Collection.extend({
  url: function () {
    return "rest/optimizations/" + this.options.optimization.id +  "/Tosca/sets/selected";
  },

  initialize: function (models, options) {
    this.options = options || {};
  }
});

window.OptimizationToscaTechnologicalConstraints = React.createClass({
  getInitialState: function () {
    return {
      constraints: new OptimizationToscaTechnologicalConstraints(null, { optimization: this.props.optimization }),
      sets: new OptimizationToscaTechnologicalConstraintSets(null, { optimization: this.props.optimization })
    };
  },
  componentDidMount: function () {
    this.totalUpdate();
    window.App.commands.setHandler("basic:NUM_TECH_CONSTRAINTS:changed", () => {
      this.fetchData().then(() => this.forceUpdate(), null);
    });
  },

  totalUpdate: function () {
    this.fetchData().then(() =>
      this.fetchSets().then(() =>
        this.fetchParameters(), null),
      null);
  },

  fetchData: function () {
    return new Promise((resolve, reject) => {
      this.state.constraints.fetch({
        success: resolve,
        error: reject
      });
    })
  },

  fetchSets: function () {
    return new Promise((resolve, reject) => {
      this.state.sets.fetch({
        success: resolve,
        error: reject
      })
    })
  },

  fetchParameters: function () {
    $.get("rest/optimizationType/" + this.props.optimization.get("optimizationTypeId") + "/Tosca/technologicalConstraints", (technologicalConstraintsDictionary) => {
      this.setState({ technologicalConstraintsDictionary: technologicalConstraintsDictionary })
    });
  },

  onMinimizeClick: function (e) {
    $(e.target).closest(".ui-collapsable-block").toggleClass("minimized");
    $(e.target).closest(".ui-minimize").find("span").toggle();
  },

  mapConstraints: function () {
    return this.state.constraints.toJSON().map((constraint) => {
      return <window.OptimizationToscaTechnologicalConstraint isView={this.props.isView} onChange={this.props.onChange} key={constraint.id} data={constraint} sets={this.state.sets} technologicalConstraintsDictionary={this.state.technologicalConstraintsDictionary}/>
    });
  },

  render: function () {
    return (
      <div className="ui-optimization-block ui-collapsable-block ui-optimization-settings-container">
        <div className="ui-optimization-block-header clearfix">
          <span className="pull-left">Определение технологических ограничений</span>
        </div>
        <div className="ui-optimization-block-body">
          <div className="row" style={{"marginBottom": "7px"}}>
            <div className="col-md-6">Пространство</div>
            <div className="col-md-6">Ограничение</div>
          </div>
          {this.mapConstraints()}
        </div>
      </div>
    )
  }
});