(function () {
  "use strict";

  window.App.Views.OptimizationSettingsPage = window.App.Views.BasePage.extend({
    template: "./views/templates/project/optimization/optimization_settings_page.html.ejs",
    ui: _.extend({
      run: ".js-run",
      getXML: ".js-get-xml"
    }, window.App.Views.BasePage.prototype.ui),

    events: _.extend({
      "click @ui.run": "onRunClick",
      "click @ui.getXML": "onGetXMLClick"
    }, window.App.Views.BasePage.prototype.events),

    initialize: function () {
      window.App.Views.BasePage.prototype.initialize.apply(this, arguments);
      this.page = "settings";
      this.controls = ["copy", "editMode", "run", "getXML"];
    },

    onGetXMLClick: function () {
      window.open("rest/optimizations/" + this.model.id + "/" + this.model.get("caoName") +  "/configFile");
    },

    onShow: function () {
      ReactDOM.render(
        React.createElement(this.getContainer(), {
          optimization: this.model,
          optimizationId: this.model.id,
          isView: this.mode == "view",
          tab: this.options.tab
        }),
        this.$(".js-main-region")[0]
      );
    },

    getContainer: function () {
      var settingsContainer;
      if (!_.isNull(this.model.get("caoName"))) {
        switch (this.model.get("caoName")) {
          case "ModeFrontier":
            settingsContainer = window.OptimizationModeFrontierContainer;
            break;
          case "Tosca":
            settingsContainer = window.OptimizationToscaContainer;
            break;
          case "Optistruct":
            settingsContainer = window.OptimizationOptistructContainer;
            break;
          case "Optimus":
            settingsContainer = window.OptimizationOptimusContainer;
            break;
        }
        return settingsContainer;
      }
    }

  });

})
();