(function () {
  "use strict";

  window.App.Views.ProjectHomeView = Marionette.LayoutView.extend({
    template: "./views/templates/project/project_home.html.ejs",
    regions: {
      materialsRegion:          ".js-recent-materials",
      compositeMaterialsRegion: ".js-recent-compositeMaterials"
    },

    initialize: function (options) {
      this.options = options || {};
    },

    onShow: function () {
      this.initRecentMaterials();
      this.initRecentCompositeMaterials();
    },

    initRecentMaterials: function () {
      this.recentMaterialsView = new window.App.Views.MaterialsListView(_.extend({
        gridCollection: new App.Collections.RecentMaterials([], {
          pageable: true,
          filters: this.options.filters || null
        }),
        actions: ["open", "new", "delete"],
        type: "materials"
      }, {}));
      this.getRegion("materialsRegion").show(this.recentMaterialsView);
    },

    initRecentCompositeMaterials: function () {
      this.recentCompositeMaterialsView = new window.App.Views.CompositeMaterialsListView(_.extend({
        gridCollection: new App.Collections.RecentCompositeMaterials([], {
          pageable: true,
          filters: this.options.filters || null
        }),
        actions: ["open", "new", "delete"],
        type: "compositeMaterials"
      }, {}));
      this.getRegion("compositeMaterialsRegion").show(this.recentCompositeMaterialsView);
    }

  });

}());