/**
 *
 * Navigation Menu View
 *
 */


(function () {
  "use strict";

  window.App.Views.ProjectNavView = Backbone.Marionette.ItemView.extend({
    template: "./views/templates/project/project_navigation.html.ejs",

    className: 'nav nav-tabs nav-justified',

    ui: {
      navigationRoute: ".navigate-route",
      support: ".js-support",
      pdfHelper: ".js-pdfHelper",
    },

    events: {
      "click @ui.navigationRoute" : "onClickNavigationRoute",
      "click @ui.support": "onSupportClick",
      "click @ui.pdfHelper": "onHelpClick"
    },

    initialize: function () {},

    onHelpClick: function () {
      var bookmark = null;
      $.ajax({
        type: "GET",
        url: "rest/help/getBookmark",
        data: {pageUrl: window.location.hash.slice(1)},
        response:'text',
        async: false,
        success: function(data){
          bookmark = data;
          return bookmark
        }
      });
      if (bookmark !== null) {window.open("rest/help/content#"+bookmark, bookmark, "left="+0.45*screen.availWidth+",top="+0.05*screen.availHeight+",width="+0.5*screen.availWidth+",height="+0.9*screen.availHeight+",menubar=no,toolbar=no,location=no")};
    },

    onClickNavigationRoute: function(e) {
      e.preventDefault();

      window.App.navigate($(e.target).data("route"), {trigger: true});
    },

    setActiveMenuItem: function (item) {
      if (this.$("#project-" + item).length > 0 ) {
        this.$('#project-' + item).tab('show').end().parent('.dropdown').tab('show');
      } else {
        this.$(".nav-tabs li").each(function () {
          $(this).removeClass("active");
        });
      }
    },

    onSupportClick: function () {
      this.supportView = new window.App.Views.SupportView();
      this.modal = new Backbone.BootstrapModal({
        content: this.supportView,
        title: "Техническая поддержка",
        animate: true,
        cancelText: "Отменить",
        okText: "Отправить"
      }).open();
    },

    templateHelpers: function() {
      return {
        role: window.App.Data.UserRole
      }
    }

  });

})();