(function () {
  "use strict";

  window.App.Views.QueueControls = Backbone.Marionette.LayoutView.extend({
    template: "./views/templates/project/queue/queue_controls.html.ejs",
    ui: {
      showTable: ".js-show-table"
    },

    events: {
      "click @ui.showTable": "onClickShowTable"
    },

    onClickShowTable: function (e) {
      var $target = $(e.target).closest(".ui-controls-icon");
      var tableName = $target.data("table");
      var isActive = $target.hasClass("active");
      $target.toggleClass("active");
      this.options.layout.trigger("toggle:shown:table", tableName);
    },

    templateHelpers: function () {
      var that = this;
      return {
        activeTableClass: function (tableName) {
          var isShown = that.options.layout.tables[tableName];
          return isShown ? "active" : "";
        }
      }
    }
  });

})();