(function () {
  "use strict";

  window.App.Views.SimulationExperimentView = Marionette.LayoutView.extend({
    template: "./views/templates/project/simulation/simulation_experiment.html.ejs",
    className: "ui-simulation-experiment col-md-8 m-t-10 customized-left-nopadding",
    behaviors: {
      PluginsInit: {
        fileupload: {
          el: "#js-file-upload"
        }
      }
    },

    ui: {
      fileForm:     ".js-file-form",
      fileInp:      "#js-file-upload"
    },

    initialize: function (options) {
      this.options = options || {};
      this.listenTo(this, "save:experiment:file", _.bind(this.saveExperimentFile, this));
    },

    saveExperimentFile: function () {
      if (this.options.mode != "view" && !_.isUndefined(this.ui.fileInp.val()) && !_.isEmpty(this.ui.fileInp.val())) {
        this.ui.fileForm.ajaxForm({
          url: "rest/simulations/" + this.model.id + "/experiment",
          type: "POST",
          error: console.error,
          async: false
        }).submit();
      }
    },

    templateHelpers: function() {
      return {
        isView: this.options.mode == "view"
      }
    }

  });

}());