(function () {
  "use strict";

  window.App.Views.SimulationMainView = Marionette.LayoutView.extend({
    template: "./views/templates/project/simulation/simulation_main.html.ejs",
    className: "ui-simulation-main row",

    behaviors: function () {
      {
        return {
          PluginsInit: {
            select2Events: [],
            select2: [
              window.App.Helpers.Select2Config({
                el: ".js-type",
                placeholder: this.options.model.get("type") ? this.options.model.get("type") : "Вид испытания",
                url: "rest/simulations/types/suggest",
                isNumber: false,
                allowClear: true,
                minimumInputLength: 0
              }),
              window.App.Helpers.Select2Config({
                el: ".js-standard",
                placeholder: this.options.model.get("standardName") ? this.options.model.get("standardName") :  "Стандарт",
                url: "rest/standards/suggest",
                isNumber: false,
                allowClear: true,
                minimumInputLength: 0
              })
            ]
          }
        }
      }
    },

    regions: {
      imageRegion: ".js-image-region"
    },

    ui: {
      "name": ".js-name",
      "typeId": ".js-type",
      "standardId": ".js-standard",
      "description": ".js-description"
    },

    events: {
      "keyup @ui.name": "onChange",
      "change @ui.typeId": "onChange",
      "change @ui.standardId": "onChange",
      "change @ui.description": "onChange"
    },

    initialize: function (options) {
      this.options = options || {};
    },

    onShow: function () {
      this.showImage();
    },

    showImage: function () {
      this.getRegion("imageRegion").show(new window.App.Views.BaseImageView({
        model: this.model,
        mode: this.options.mode,
        objectType: "simulations",
        allowVerticalAlign: true
      }));
    },

    onChange: function (e) {
      var $target = $(e.target);
      var key = $target.attr("id");
      var value = this.ui[key].val();
      if (key == "name") {
        if (value.length == 0) {
          this.ui.name.closest(".form-group").addClass("has-error");
          window.alertify.error("Название не может быть пустым.");
          return;
        } else {
          this.ui.name.closest(".form-group").removeClass("has-error");
        }
      }
      this.model.set(key, value);
    },

    templateHelpers: function() {
      return {
        isView: this.options.mode == "view"
      }
    }

  });

}());