(function () {
  "use strict";

  window.App.Views.SimulationParametersView = Marionette.LayoutView.extend({
    template: "./views/templates/project/simulation/simulation_parameters.html.ejs",
    className: "ui-simulation-parameters col-md-4 m-t-10",

    ui: {
      "valIn": ".js-val"
    },

    events: {
      "change @ui.valIn": "onChange"
    },

    initialize: function (options) {
      this.options = options || {};
    },

    onChange: function (e) {
      var $target = $(e.target);
      var key = $target.data("id");
      var value = _.isEmpty($target.val()) ? null : $target.val();
      this.model.set(key, value);
    },

    templateHelpers: function() {
      return {
        isView: this.options.mode == "view"
      }
    }

  });

}());