(function() {
  "use strict";
  var RunningTasksGridView = window.App.Views.BackgridBasePageView.extend({

    id: "runningtasks-grid-view",

    title: "Running Tasks",

    contextMenuTemplate: "./views/templates/project/context_menu/task_menu.html.ejs"

  });
  window.App.Views.ProjectTasksRunningView = Backbone.Marionette.LayoutView.extend({

    template: "./views/templates/project/project_tasks_running.html.ejs",

    regions: {
      tasksGridRegion: "#runnigtasks-backgrid-region"
    },

    initialize: function(options) {
      this.options = options || {};
      this.runningTasksGrid = new RunningTasksGridView(_.extend(options, {showTools: false, selectable: false}));
    },

    onRender: function () {
      this.globalChannel = Backbone.Wreqr.radio.channel('global');
      this.globalChannel.commands.setHandler("contextmenu:selected:taskstart", this.taskStart.bind(this))
      this.globalChannel.commands.setHandler("contextmenu:selected:taskstop", this.taskStop.bind(this))
    },

    onDestroy: function () {
      this.globalChannel.commands.removeHandler("contextmenu:selected:taskstart");
      this.globalChannel.commands.removeHandler("contextmenu:selected:taskstop");
    },

    taskStop: function (id) {
      $.ajax(this.options.gridCollection.url + "/" + id + "/stop", {
        type: "PUT",
        success: function (res) {
          window.alertify.success("Stopped");
        }
      });
    },
    taskStart: function (id) {

      $.ajax(this.options.gridCollection.url + "/" + id + "/start", {
        success: function (res) {
          window.alertify.success("Started");
        }
      });
    },
    onShow: function() {
      this.tasksGridRegion.show(this.runningTasksGrid);
    }
  });

})();