(function () {
  "use strict";

  window.App.Views.CreateTechnologyDefectView = window.App.Views.CreateTechnologyParameterView.extend({
    template: "./views/templates/project/technology/create_technology_technologyDefects.html.ejs",
    className: "create-technology row",

    behaviors: {
      PluginsInit: {
        select2Events: [],
        select2: [
          new window.App.Helpers.Select2Config({
            el: ".js-name-type",
            placeholder: "Выберите дефект",
            url: "rest/technologies/defects/suggest",
            isNumber: false,
            allowClear: true
          })
        ],
        fileupload: {
          el: "#js-file-upload"
        },
        ajaxFormConfig: {}
      }
    },

    ui: _.extend({
      name:     ".js-name-type",
      value:    ".js-value",
      actName:  ".js-act-name",
      file:     ".js-file",
      fileForm: ".js-file-form"
    }, window.App.Views.CreateTechnologyParameterView.prototype.ui),

    onSubmit: function (md) {
      md.preventClose();
      var that = this;
      var isValidated = true;

      if (_.isEmpty(this.ui.name.val())) {
        this.ui.name.closest(".form-group").removeClass("has-success").addClass("has-error");
        isValidated = false;
      } else { this.ui.name.closest(".form-group").removeClass("has-error").addClass("has-success"); }

      if (_.isEmpty(this.ui.value.val())) {
        this.ui.value.closest(".form-group").removeClass("has-success").addClass("has-error");
        isValidated = false;
      } else { this.ui.value.closest(".form-group").removeClass("has-error").addClass("has-success"); }


      if (_.isEmpty(this.ui.actName.val()) && _.isEmpty(this.ui.file.val())) {
        this.ui.actName.closest(".form-group").removeClass("has-success").addClass("has-error");
        this.ui.file.closest(".form-group").removeClass("has-success").addClass("has-error");
        isValidated = false;
      }

      if (!_.isEmpty(this.ui.actName.val())) {
        this.ui.actName.closest(".form-group").removeClass("has-error").addClass("has-success");
      }

      if (!_.isEmpty(this.ui.file.val())) {
        this.ui.file.closest(".form-group").removeClass("has-error").addClass("has-success");
      }

      if (isValidated) {
        this.ui.fileForm.ajaxForm({
          type: "POST",
          url: "rest/technologies/" +  this.options.technologyId + "/defects",
          success: function () {
            window.alertify.success("Дефект успешно создан.");
            window.App.navigate("#project/technologies/" + that.options.technologyId + "/parameters/view", { trigger: true })
            md.close();
          },
          error: function () {}
        }).submit();
      }


    }

  });

}());