(function () {
  "use strict";

  window.App.Views.CreateTechnologyParameterView = Marionette.LayoutView.extend({
    template: "./views/templates/project/technology/create_technology_technologyParameters.html.ejs",
    className: "create-technology row",

    ui: {
      input: ".js-input"
    },

    initialize: function (options) {
      this.template = "./views/templates/project/technology/create_technology_" + options.parameterType + ".html.ejs";
      this.options = options || {};
      this.listenTo(this, "ok", this.onSubmit);
      this.listenTo(this, "cancel", this.onCancel);
    },

    passModal: function (md) {
      this.md = md;
    },

    onSubmit: function (md) {
      md.preventClose();
      var that = this;
      var isValidated = true;
      var data = {};
      $.each(this.ui.input, function (index, input) {
        var name = $(input).attr("id");
        var value = $(input).val();
        if (_.isEmpty(value)) {
          isValidated = false;
          $(input).closest('.form-group').removeClass("has-success").addClass("has-error");
        } else {
          $(input).closest('.form-group').removeClass("has-error").addClass("has-success");
          data[name] = value;
        }
      });

      if (isValidated) {
        $.ajax({
          type: "POST",
          url: "rest/technologies/" + this.options.technologyId + "/" + this.options.parameterType.replace("technology", "").toLocaleLowerCase(),
          data: JSON.stringify(data),
          contentType: "application/json",
          success: function () {
            window.App.navigate("#project/technologies/" + that.options.technologyId + "/parameters/view", { trigger: true });
            md.close();
          }
        });
      } else {
        window.alertify.error("Все поля должны быть заполнены.")
      }
    },

    onCancel: function () {
      window.App.navigate("#project/technologies/" + this.options.technologyId + "/parameters/view", { trigger: true });
    }

  });

}());