/**
 * Created by mamchits on 7/4/2017.
 */
(function () {
    "use strict";

    window.App.Views.CreateTechnologySimulationView = Marionette.LayoutView.extend({
        template: "./views/templates/project/technology/create_technology_simulation.html.ejs",
        ui: {
            "name": ".js-name"
        },

        initialize: function (options) {
            this.options = options || {};
            this.model = new window.App.Models.TechnologySimulation({}, { technologyId: this.options.technologyId });
            this.listenTo(this, "ok", this.onSubmit);
            this.listenTo(this, "cancel", this.onCancel);
        },

        passModal: function (md) {
            this.md = md;
        },

        onCancel: function() {
            window.App.navigate("#project/technologies/" + this.options.technologyId + "/technologySimulations/view", { trigger: true });
        },

        onSubmit: function(md) {
            md.preventClose();
            var name = this.ui.name.val();

            if (_.isEmpty(name))
                this.ui.name.closest(".form-group").addClass("has-error");
            else {
                var that=this;
                this.model.save({
                    name: name,
                    technologyId: this.options.technologyId
                }, {
                    success: function(model, resp) {
                        window.App.navigate("#project/technologySimulations/" + model.get("id") + "/parameters/edit", { trigger: true });
                        md.close();
                    }
                });
            }
        }

    });

}());