(function () {
  "use strict";
  window.App.Views.TechnologySimulationParametersPage = window.App.Views.BasePage.extend({
    template: "./views/templates/project/technology/technology_simulation_parameters_page.html.ejs",

    regions: _.extend({
        "workspaceRegion": ".js-workspace-region",
        "ribsRegion": ".js-ribs-region"
    }, window.App.Views.BasePage.prototype.regions),

    ui: _.extend({}, window.App.Views.BasePage.prototype.ui),

    events: _.extend({}, window.App.Views.BasePage.prototype.events),

    initialize: function (options) {
      window.App.Views.BasePage.prototype.initialize.apply(this, arguments);
      this.controls = ["edit","copy","runTS"];
    },

    onRender: function () {
      this.initAndShowWorkspaceView(this.getRegion("workspaceRegion"));
      this.initAndShowRibsView(this.getRegion("ribsRegion"));
      window.App.Views.BasePage.prototype.onRender.call(this);
    },

    initAndShowWorkspaceView: function (region) {
        var that = this;
        this.workspaceParameters = new window.App.Collections.WorkspaceParameters({ technologySimulationId: this.model.id });
        this.workspaceParameters.fetch({
            success: function () {
                that.technologySimulationWorkspaceView = new window.App.Views.TechnologySimulationWorkspaceView({
                    layoutView: that,
                    mode: that.mode,
                    collection: that.workspaceParameters,
                    technologySimulationId: that.model.id
                });
                region.show(that.technologySimulationWorkspaceView);
            }
        });
    },

      initAndShowRibsView: function (region) {
          var that = this;
          this.ribParameters = new window.App.Collections.RibParameters({technologySimulationId: this.model.id});
          this.ribParameters.fetch({
              success: function () {
                  that.technologySimulationRibsView = new window.App.Views.TechnologySimulationRibsView({
                      layoutView: that,
                      mode: that.mode,
                      collection: that.ribParameters,
                      technologySimulationId: that.model.id
                  });
                  region.show(that.technologySimulationRibsView);
              }
          });
      },
  })

})();