(function () {
  "use strict";

  window.App.Views.TechnologySimulationWorkspaceView = Marionette.LayoutView.extend({
    template: "./views/templates/project/technology/technology_simulation_workspace_view.html.ejs",
    className: "ui-technology-simulation-main row",

    ui: {
        PRINT_RECT_MIN_X:         ".js-PRINT_RECT_MIN_X",
        PRINT_RECT_MIN_Y:         ".js-PRINT_RECT_MIN_Y",
        PRINT_RECT_MAX_X:         ".js-PRINT_RECT_MAX_X",
        PRINT_RECT_MAX_Y:         ".js-PRINT_RECT_MAX_Y",
        USEFUL_RECT_MIN_X:         ".js-USEFUL_RECT_MIN_X",
        USEFUL_RECT_MIN_Y:         ".js-USEFUL_RECT_MIN_Y",
        USEFUL_RECT_MAX_X:         ".js-USEFUL_RECT_MAX_X",
        USEFUL_RECT_MAX_Y:         ".js-USEFUL_RECT_MAX_Y",
        MIN_RADIUS:         ".js-MIN_RADIUS",
        NUM_LEVELS:         ".js-NUM_LEVELS",
        VERTICAL_STEP:         ".js-VERTICAL_STEP",
        LINE_FEED_RATE:         ".js-LINE_FEED_RATE",
        ARC_FEED_RATE:         ".js-ARC_FEED_RATE",
        LINE_EXTRUSION_RATE:         ".js-LINE_EXTRUSION_RATE",
        ARC_EXTRUSION_RATE:         ".js-ARC_EXTRUSION_RATE"
    },

    events: {
      "change @ui.PRINT_RECT_MIN_X":             "onChange",
      "change @ui.PRINT_RECT_MIN_Y":             "onChange",
      "change @ui.PRINT_RECT_MAX_X":             "onChange",
      "change @ui.PRINT_RECT_MAX_Y":             "onChange",
      "change @ui.USEFUL_RECT_MIN_X":             "onChange",
      "change @ui.USEFUL_RECT_MIN_Y":             "onChange",
      "change @ui.USEFUL_RECT_MAX_X":             "onChange",
      "change @ui.USEFUL_RECT_MAX_Y":             "onChange",
      "change @ui.MIN_RADIUS":             "onChange",
      "change @ui.NUM_LEVELS":             "onChange",
      "change @ui.VERTICAL_STEP":             "onChange",
      "change @ui.LINE_FEED_RATE":             "onChange",
      "change @ui.ARC_FEED_RATE":             "onChange",
      "change @ui.LINE_EXTRUSION_RATE":             "onChange",
      "change @ui.ARC_EXTRUSION_RATE":             "onChange",
    },

    initialize: function (options) {
      this.options = options || {};
    },

    onChange: function (e) {
      var $target = $(e.target);
      var key = $target.attr("id");
      var value = parseFloat(this.ui[key].val());
      if ( !(!isNaN(value) && isFinite(value))) {
          this.ui[key].closest(".form-group").addClass("has-error");
          window.alertify.error("Введите число.");
          return;
      }
      else{
          this.ui[key].closest(".form-group").removeClass("has-error");
      }
      switch (key) {
          case ("PRINT_RECT_MIN_X"):
            var kid = 8;
            break;
          case ("PRINT_RECT_MIN_Y"):
            var kid = 9;
            break;
          case ("PRINT_RECT_MAX_X"):
            var kid = 10;
            break;
          case ("PRINT_RECT_MAX_Y"):
            var kid = 11;
            break;
          case ("USEFUL_RECT_MIN_X"):
            var kid = 12;
            break;
          case ("USEFUL_RECT_MIN_Y"):
            var kid = 13;
            break;
          case ("USEFUL_RECT_MAX_X"):
            var kid = 14;
            break;
          case ("USEFUL_RECT_MAX_Y"):
            var kid = 15;
            break;
          case ("MIN_RADIUS"):
            var kid = 1;
            break;
          case ("NUM_LEVELS"):
            var kid = 2;
            break;
          case ("VERTICAL_STEP"):
            var kid = 3;
            break;
          case ("LINE_FEED_RATE"):
            var kid = 4;
            break;
          case ("LINE_EXTRUSION_RATE"):
            var kid = 5;
            break;
          case ("ARC_FEED_RATE"):
            var kid = 6;
            break;
          case ("ARC_EXTRUSION_RATE"):
            var kid = 7;
            break;
      }
      this.model = this.collection.findWhere({parameterId: kid}) || new window.App.Models.WorkspaceParameter({
          technologySimulationId: this.options.technologySimulationId,
          parameterId: kid,
      });
      this.model.set({parameterValue: value});
      var that = this;
      this.model.save({}, {
          success: function () {
              that.collection.fetch();
          },
          error: function (model, xhr) {
              if (xhr.status == 200) that.collection.fetch();
          }
      });
    },

    templateHelpers: function() {
      return {
        isView: this.options.mode == "view",
        workspaceParameters: this.collection.toJSON()
      }
    }

  });

}());