(function() {
    "use strict";
    window.App.Views.TechnologySimulationsPage = window.App.Views.BasePage.extend({
        template: "./views/templates/project/technology/technology_simulations_page.html.ejs",

    initialize: function (options) {
        //window.App.Views.MaterialFilesPage.__super__.initialize.apply(this, arguments);
        //this.controls = ["new","edit"];
        this.controls = ["new"];
        this.page = this.options.fileType;
        //this.page = "technologySimulations";
    },

    onShow: function () {
        this.initAndDrawTables();
    },

    initAndDrawTables: function () {
        var gridCollection = new window.App.Collections.TechnologySimulations([], {
            dependsOnParent: false,
            pageable: true,
            filters: _.extend({ technologyId: this.model.id }, this.options.filters) || null
        });

        this.filesView = new window.App.Views.TechnologySimulationsListView(_.extend({
            gridCollection: gridCollection,
            actions: ["open", "new", "delete"],
            title: "Технологические расчеты",
            type: this.options.type
        }, {}));
        this.getRegion("mainRegion").show(this.filesView);
    },

    initAndShowControlsView: function (region) {
        this.controlsView = new window.App.Views.TechnologySimulationControlsView({
            layoutView: this,
            model: this.model,
            controls: this.controls
        });
        region.show(this.controlsView);
    }

    });
})();