(function () {

  "use strict";

  window.App.Views.ChangePasswordModal = Backbone.Marionette.LayoutView.extend({
    template: "./views/templates/project/change_password_modal.html.ejs",
    className: "clearfix",

    ui: {
      oldPassword: "#js-old-password",
      newPassword: "#js-new-password",
      newPasswordConfirm: "#js-new-password-confirm"
    },

    initialize: function() {
      this.listenTo(this, "ok", this.onChangeClick);
    },

    onChangeClick: function(modal) {
      modal.preventClose();
      var oldPassword = this.ui.oldPassword.val();
      var newPassword = this.ui.newPassword.val();
      var newPasswordConfirm = this.ui.newPasswordConfirm.val();

      //Compare new password and confirmation of new password
      if (newPassword === newPasswordConfirm) {
        var userPasswordModel = new window.App.Models.UserPassword({ userId: this.model.get("id") });

        userPasswordModel.set("oldPassword", oldPassword);
        userPasswordModel.set("newPassword", newPassword);

        userPasswordModel.save(userPasswordModel.toJSON(), {
          type: 'PUT',
          success: function (data) {
            window.alertify.success("Пароль успешно изменен");
            modal.close();
          }
        });
      }
      else {
        window.alertify.error("Подтверждение не совпадает с паролем.");
        this.ui.newPassword.val('');
        this.ui.newPasswordConfirm.val('');
      }
    }

  });

}());
