(function () {
  "use strict";

  window.App.Views.CreateUserView = Backbone.Marionette.LayoutView.extend({
    template: "./views/templates/project/create_user.html.ejs",

    ui: {
      field:      ".js-field",
      saveBtn:    ".js-save",
      clearBtn:   ".js-clear"
    },

    events: {
      "click @ui.saveBtn":  "onSaveBtnClick",
      "click @ui.clearBtn": "onClearBtnClick"
    },

    onSaveBtnClick: function () {
      var that = this;
      var hasError = false;
      $.each(this.ui.field, function (index, field) {
        if ($(field).attr("id") !== "phone" && _.isEmpty($(field).val())) {
          $(field).closest(".form-group").addClass("has-error");
          hasError = true;
        }
      });
      if (this.$("#password").val() != this.$("#password-confirm").val()) {
        this.$("#password").closest(".form-group").addClass("has-error");
        this.$("#password-confirm").closest(".form-group").addClass("has-error");
        window.alertify.error("Пароли не совпадают.")
        hasError = true;
      }
      if (hasError) return false;
      this.model = new window.App.Models.User();
      this.model.set({
        name:   this.$("#name").val(),
        login:  this.$("#login").val(),
        password:  this.$("#password").val(),
        email:  this.$("#email").val(),
        phone:  this.$("#phone").val(),
        roleId: this.$("#roleId").val()
      });
      this.model.save({}, {
        success: function () {
          window.App.navigate("#profile/" + that.model.id + "/view", { trigger: true });
        }
      });
    }

  });

}());