(function() {
  "use strict";

  window.App.Views.Users = window.App.Views.BackgridBasePageView.extend({

    contextMenuTemplate: null,

    id: "users-view",

    title: "Пользователи",

    onRender: function () {
      if (window.App.Data.UserRole !== "Senior" && window.App.Data.UserRole !== "Administrator") this.$el.find("#create-new").addClass("hidden");
      this.globalChannel = Backbone.Wreqr.radio.channel('global');
      this.globalChannel.commands.setHandler("contextmenu:selected:useropen", this.userOpen.bind(this))
      this.globalChannel.commands.setHandler("contextmenu:selected:setactive", this.setActive.bind(this))
      this.globalChannel.commands.setHandler("contextmenu:selected:resetpassword", this.resetPassword.bind(this))
      this.globalChannel.commands.setHandler("contextmenu:selected:userdelete", this.deleteUser.bind(this))
    },

    onDestroy: function () {
      this.globalChannel.commands.removeHandler("contextmenu:selected:useropen");
      this.globalChannel.commands.removeHandler("contextmenu:selected:setactive");
      this.globalChannel.commands.removeHandler("contextmenu:selected:resetpassword");
      this.globalChannel.commands.removeHandler("contextmenu:selected:userdelete");
    },

    userOpen: function (model) {
      Backbone.history.navigate("profile/" + model.id + "/show/", {trigger: true});
    },

    setActive: function (model) {
      if (model.get("role") === "Administrator" && window.App.Data.UserRole !== "Administrator") {
        window.alertify.error("You don't have enough right to block/unblock this user.");
        return false;
      }
      $.ajax(model.url() + "/block", {
        type: "GET",
        contentType: "application/json",
        success: function (res) {
          window.alertify.success("Success");
        }
      });
    },

    deleteUser: function (model) {
      var that = this;
      $.ajax(model.url(), {
        type: "DELETE",
        success: function (res) {
          window.alertify.success("Deleted");
          that.options.gridCollection.fetch()
        }
      });
    },

    resetPassword: function (model) {
      var that = this;
      $.ajax(model.url() + "/password-reset", {
        type: "POST",
        success: function (res) {
          window.alertify.success("Success");
        }
      });
    }
  });

}());