package ru.crp.lvms;

import org.junit.Test;
import org.springframework.beans.factory.annotation.Autowired;
import ru.crp.lvms.optimizations.base.entities.OptimizationEntity;
import ru.crp.lvms.optimizations.mf.config.MFConfigGenerator;
import ru.crp.lvms.optimizations.mf.managers.MFOptimizationSettingsManager;

import java.nio.file.Files;
import java.nio.file.Path;

public class ConfigXmlGenerationTest extends BaseIT {

    @Autowired
    private MFConfigGenerator MFConfigGenerator;

    @Autowired
    private MFOptimizationSettingsManager MFOptimizationSettingsManager;


    @Test
    public void testConfigCreation() throws Exception {
        OptimizationEntity optimization = projectCreator.createOptimization();
        MFOptimizationSettingsManager.selectAlgorithm(optimization.getId(), 8);
        MFOptimizationSettingsManager.selectDoe(optimization.getId(), 11);
        Path tempConfigFile = MFConfigGenerator.generateConfig(optimization);
        Files.delete(tempConfigFile);
    }
}
