package ru.crp.lvms;

import com.fasterxml.jackson.databind.JsonNode;
import org.junit.Assert;
import ru.crp.cmlb.model.entities.base.Entity;
import ru.crp.lvms.model.entities.tasks.TaskEntity;
import ru.crp.lvms.utils.TestUtils;
import ru.crp.lvms.utils.URLs;

import java.util.List;
import java.util.function.Function;
import java.util.function.Supplier;

import static ru.crp.lvms.utils.TestUtils.unique;

public class TasksEndpointIT extends CRUDIT<TaskEntity, TaskEntity> {

    @Override
    public String setUrl() {
        return URLs.TASKS_URL;
    }

    @Override
    public Supplier<TaskEntity> setEntityCreator() {
        return projectCreator::createTask;
    }

    @Override
    public Supplier<TaskEntity> setEntityInitialisation() {
        return projectCreator::newTask;
    }

    @Override
    public Function<JsonNode, List<? extends Entity>> setJsonFromList() {
        return TestUtils::tasksFromJson;
    }

    @Override
    public Function<JsonNode, List<? extends Entity>> setJsonFromPage() {
        return TestUtils::tasksPageFromJson;
    }

    @Override
    public void update(TaskEntity toUpdate) {
        toUpdate.setAdditionalStartupArguments(unique("startup arguments"));
    }

    @Override
    public void validateAfterUpdate(TaskEntity before, TaskEntity after) {
        Assert.assertEquals(before.getAdditionalStartupArguments(), after.getAdditionalStartupArguments());
    }
}
