package ru.crp.lvms.technologies;

import com.fasterxml.jackson.databind.JsonNode;
import org.junit.Assert;
import ru.crp.cmlb.model.entities.base.Entity;
import ru.crp.lvms.CRUDIT;
import ru.crp.lvms.model.entities.PossibleDefectsEntity;
import ru.crp.lvms.utils.TestUtils;

import java.util.List;
import java.util.function.Function;
import java.util.function.Supplier;

public class PossibleDefectsEndpointIT extends CRUDIT<PossibleDefectsEntity, PossibleDefectsEntity> {

    @Override
    public String setUrl() {
        return projectCreator.getUrlForPossibleDefects();
    }

    @Override
    public Supplier<PossibleDefectsEntity> setEntityCreator() {
        return projectCreator::createPossibleDefectsEntity;
    }

    @Override
    public Supplier<PossibleDefectsEntity> setEntityInitialisation() {
        return () -> projectCreator.newPossibleDefectsEntity();
    }

    @Override
    public Function<JsonNode, List<? extends Entity>> setJsonFromList() {
        return TestUtils::possibleDefectsFromJson;
    }

    @Override
    public Function<JsonNode, List<? extends Entity>> setJsonFromPage() {
        return TestUtils::possibleDefectsPageFromJson;
    }

    @Override
    public void update(PossibleDefectsEntity toUpdate) {
        toUpdate.setActName("testActName");
    }

    @Override
    public void validateAfterUpdate(PossibleDefectsEntity before, PossibleDefectsEntity after) {
        Assert.assertEquals(before.getActName(), after.getActName());
    }
}
